using System;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace SharpDX;

[Serializable]
[StructLayout(LayoutKind.Sequential, Pack = 4)]
[DefaultMember("Item")]
public struct ae : IEquatable<ae>, IFormattable
{
	public float a;

	public float b;

	public float c;

	public float d;

	public ae(float A_0)
	{
		this.d = (this.a = (this.b = (this.c = A_0)));
	}

	public ae(float A_0, float A_1, float A_2, float A_3)
	{
		this.d = A_0;
		this.a = A_1;
		this.b = A_2;
		this.c = A_3;
	}

	public ae(i A_0)
	{
		this.a = A_0.h;
		this.b = A_0.i;
		this.c = A_0.j;
		this.d = A_0.k;
	}

	public ae(a A_0, float A_1)
	{
		this.a = A_0.g;
		this.b = A_0.h;
		this.c = A_0.i;
		this.d = A_1;
	}

	public ae(int A_0)
	{
		this.d = (float)((A_0 >> 24) & 0xFF) / 255f;
		this.a = (float)((A_0 >> 16) & 0xFF) / 255f;
		this.b = (float)((A_0 >> 8) & 0xFF) / 255f;
		this.c = (float)(A_0 & 0xFF) / 255f;
	}

	public ae(float[] A_0)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("values");
		}
		if (A_0.Length != 4)
		{
			throw new ArgumentOutOfRangeException("values", "There must be four and only four input values for Color4.");
		}
		this.d = A_0[0];
		this.a = A_0[1];
		this.b = A_0[2];
		this.c = A_0[3];
	}

	[SpecialName]
	public float b(int A_0)
	{
		return A_0 switch
		{
			0 => this.d, 
			1 => this.a, 
			2 => this.b, 
			3 => this.c, 
			_ => throw new ArgumentOutOfRangeException("index", "Indices for Color4 run from 0 to 3, inclusive."), 
		};
	}

	[SpecialName]
	public void a(int A_0, float A_1)
	{
		switch (A_0)
		{
		case 0:
			this.d = A_1;
			break;
		case 1:
			this.a = A_1;
			break;
		case 2:
			this.b = A_1;
			break;
		case 3:
			this.c = A_1;
			break;
		default:
			throw new ArgumentOutOfRangeException("index", "Indices for Color4 run from 0 to 3, inclusive.");
		}
	}

	public int a()
	{
		uint num = (uint)(this.d * 255f);
		uint num2 = (uint)(this.a * 255f);
		uint num3 = (uint)(this.b * 255f);
		uint num4 = (uint)(this.c * 255f);
		uint num5 = num4;
		num5 += num3 << 8;
		num5 += num2 << 16;
		return (int)(num5 + (num << 24));
	}

	public a e()
	{
		return new a(this.a, this.b, this.c);
	}

	public i f()
	{
		return new i(this.a, this.b, this.c, this.d);
	}

	public float[] b()
	{
		return new float[4] { this.d, this.a, this.b, this.c };
	}

	public static void e(ref ae A_0, ref ae A_1, out ae A_2)
	{
		A_2.d = A_0.d + A_1.d;
		A_2.a = A_0.a + A_1.a;
		A_2.b = A_0.b + A_1.b;
		A_2.c = A_0.c + A_1.c;
	}

	public static ae j(ae A_0, ae A_1)
	{
		return new ae(A_0.d + A_1.d, A_0.a + A_1.a, A_0.b + A_1.b, A_0.c + A_1.c);
	}

	public static void d(ref ae A_0, ref ae A_1, out ae A_2)
	{
		A_2.d = A_0.d - A_1.d;
		A_2.a = A_0.a - A_1.a;
		A_2.b = A_0.b - A_1.b;
		A_2.c = A_0.c - A_1.c;
	}

	public static ae i(ae A_0, ae A_1)
	{
		return new ae(A_0.d - A_1.d, A_0.a - A_1.a, A_0.b - A_1.b, A_0.c - A_1.c);
	}

	public static void c(ref ae A_0, ref ae A_1, out ae A_2)
	{
		A_2.d = A_0.d * A_1.d;
		A_2.a = A_0.a * A_1.a;
		A_2.b = A_0.b * A_1.b;
		A_2.c = A_0.c * A_1.c;
	}

	public static ae h(ae A_0, ae A_1)
	{
		return new ae(A_0.d * A_1.d, A_0.a * A_1.a, A_0.b * A_1.b, A_0.c * A_1.c);
	}

	public static void c(ref ae A_0, float A_1, out ae A_2)
	{
		A_2.d = A_0.d * A_1;
		A_2.a = A_0.a * A_1;
		A_2.b = A_0.b * A_1;
		A_2.c = A_0.c * A_1;
	}

	public static ae d(ae A_0, float A_1)
	{
		return new ae(A_0.d * A_1, A_0.a * A_1, A_0.b * A_1, A_0.c * A_1);
	}

	public static void a(ref ae A_0, out ae A_1)
	{
		A_1.d = 1f - A_0.d;
		A_1.a = 1f - A_0.a;
		A_1.b = 1f - A_0.b;
		A_1.c = 1f - A_0.c;
	}

	public static ae f(ae A_0)
	{
		return new ae(1f - A_0.d, 1f - A_0.a, 1f - A_0.b, 1f - A_0.c);
	}

	public static void a(ref ae A_0, ref ae A_1, ref ae A_2, out ae A_3)
	{
		float num = A_0.d;
		num = ((num > A_2.d) ? A_2.d : num);
		num = ((num < A_1.d) ? A_1.d : num);
		float num2 = A_0.a;
		num2 = ((num2 > A_2.a) ? A_2.a : num2);
		num2 = ((num2 < A_1.a) ? A_1.a : num2);
		float num3 = A_0.b;
		num3 = ((num3 > A_2.b) ? A_2.b : num3);
		num3 = ((num3 < A_1.b) ? A_1.b : num3);
		float num4 = A_0.c;
		num4 = ((num4 > A_2.c) ? A_2.c : num4);
		num4 = ((num4 < A_1.c) ? A_1.c : num4);
		A_3 = new ae(num, num2, num3, num4);
	}

	public static ae a(ae A_0, ae A_1, ae A_2)
	{
		a(ref A_0, ref A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void b(ref ae A_0, ref ae A_1, float A_2, out ae A_3)
	{
		A_3.d = A_0.d + A_2 * (A_1.d - A_0.d);
		A_3.a = A_0.a + A_2 * (A_1.a - A_0.a);
		A_3.b = A_0.b + A_2 * (A_1.b - A_0.b);
		A_3.c = A_0.c + A_2 * (A_1.c - A_0.c);
	}

	public static ae b(ae A_0, ae A_1, float A_2)
	{
		return new ae(A_0.d + A_2 * (A_1.d - A_0.d), A_0.a + A_2 * (A_1.a - A_0.a), A_0.b + A_2 * (A_1.b - A_0.b), A_0.c + A_2 * (A_1.c - A_0.c));
	}

	public static void a(ref ae A_0, ref ae A_1, float A_2, out ae A_3)
	{
		A_2 = ((A_2 > 1f) ? 1f : ((A_2 < 0f) ? 0f : A_2));
		A_2 = A_2 * A_2 * (3f - 2f * A_2);
		A_3.d = A_0.d + (A_1.d - A_0.d) * A_2;
		A_3.a = A_0.a + (A_1.a - A_0.a) * A_2;
		A_3.b = A_0.b + (A_1.b - A_0.b) * A_2;
		A_3.c = A_0.c + (A_1.c - A_0.c) * A_2;
	}

	public static ae a(ae A_0, ae A_1, float A_2)
	{
		A_2 = ((A_2 > 1f) ? 1f : ((A_2 < 0f) ? 0f : A_2));
		A_2 = A_2 * A_2 * (3f - 2f * A_2);
		return new ae(A_0.d + (A_1.d - A_0.d) * A_2, A_0.a + (A_1.a - A_0.a) * A_2, A_0.b + (A_1.b - A_0.b) * A_2, A_0.c + (A_1.c - A_0.c) * A_2);
	}

	public static void b(ref ae A_0, ref ae A_1, out ae A_2)
	{
		A_2.d = ((A_0.d > A_1.d) ? A_0.d : A_1.d);
		A_2.a = ((A_0.a > A_1.a) ? A_0.a : A_1.a);
		A_2.b = ((A_0.b > A_1.b) ? A_0.b : A_1.b);
		A_2.c = ((A_0.c > A_1.c) ? A_0.c : A_1.c);
	}

	public static ae g(ae A_0, ae A_1)
	{
		b(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(ref ae A_0, ref ae A_1, out ae A_2)
	{
		A_2.d = ((A_0.d < A_1.d) ? A_0.d : A_1.d);
		A_2.a = ((A_0.a < A_1.a) ? A_0.a : A_1.a);
		A_2.b = ((A_0.b < A_1.b) ? A_0.b : A_1.b);
		A_2.c = ((A_0.c < A_1.c) ? A_0.c : A_1.c);
	}

	public static ae f(ae A_0, ae A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void b(ref ae A_0, float A_1, out ae A_2)
	{
		A_2.d = A_0.d;
		A_2.a = 0.5f + A_1 * (A_0.a - 0.5f);
		A_2.b = 0.5f + A_1 * (A_0.b - 0.5f);
		A_2.c = 0.5f + A_1 * (A_0.c - 0.5f);
	}

	public static ae c(ae A_0, float A_1)
	{
		return new ae(A_0.d, 0.5f + A_1 * (A_0.a - 0.5f), 0.5f + A_1 * (A_0.b - 0.5f), 0.5f + A_1 * (A_0.c - 0.5f));
	}

	public static void a(ref ae A_0, float A_1, out ae A_2)
	{
		float num = A_0.a * 0.2125f + A_0.b * 0.7154f + A_0.c * 0.0721f;
		A_2.d = A_0.d;
		A_2.a = num + A_1 * (A_0.a - num);
		A_2.b = num + A_1 * (A_0.b - num);
		A_2.c = num + A_1 * (A_0.c - num);
	}

	public static ae b(ae A_0, float A_1)
	{
		float num = A_0.a * 0.2125f + A_0.b * 0.7154f + A_0.c * 0.0721f;
		return new ae(A_0.d, num + A_1 * (A_0.a - num), num + A_1 * (A_0.b - num), num + A_1 * (A_0.c - num));
	}

	[SpecialName]
	public static ae e(ae A_0, ae A_1)
	{
		return new ae(A_0.d + A_1.d, A_0.a + A_1.a, A_0.b + A_1.b, A_0.c + A_1.c);
	}

	[SpecialName]
	public static ae e(ae A_0)
	{
		return A_0;
	}

	[SpecialName]
	public static ae d(ae A_0, ae A_1)
	{
		return new ae(A_0.d - A_1.d, A_0.a - A_1.a, A_0.b - A_1.b, A_0.c - A_1.c);
	}

	[SpecialName]
	public static ae d(ae A_0)
	{
		return new ae(0f - A_0.d, 0f - A_0.a, 0f - A_0.b, 0f - A_0.c);
	}

	[SpecialName]
	public static ae a(float A_0, ae A_1)
	{
		return new ae(A_1.d * A_0, A_1.a * A_0, A_1.b * A_0, A_1.c * A_0);
	}

	[SpecialName]
	public static ae a(ae A_0, float A_1)
	{
		return new ae(A_0.d * A_1, A_0.a * A_1, A_0.b * A_1, A_0.c * A_1);
	}

	[SpecialName]
	public static ae c(ae A_0, ae A_1)
	{
		return new ae(A_0.d * A_1.d, A_0.a * A_1.a, A_0.b * A_1.b, A_0.c * A_1.c);
	}

	[SpecialName]
	public static bool b(ae A_0, ae A_1)
	{
		return A_0.g(A_1);
	}

	[SpecialName]
	public static bool a(ae A_0, ae A_1)
	{
		return !A_0.g(A_1);
	}

	[SpecialName]
	public static ah c(ae A_0)
	{
		return new ah(A_0.a, A_0.b, A_0.c);
	}

	[SpecialName]
	public static a b(ae A_0)
	{
		return new a(A_0.a, A_0.b, A_0.c);
	}

	[SpecialName]
	public static i a(ae A_0)
	{
		return new i(A_0.a, A_0.b, A_0.c, A_0.d);
	}

	[SpecialName]
	public static ae a(a A_0)
	{
		return new ae(A_0.g, A_0.h, A_0.i, 1f);
	}

	[SpecialName]
	public static ae a(i A_0)
	{
		return new ae(A_0.h, A_0.i, A_0.j, A_0.k);
	}

	[SpecialName]
	public static ae a(int A_0)
	{
		return new ae(A_0);
	}

	public string d()
	{
		return string.Format(CultureInfo.CurrentCulture, "Alpha:{0} Red:{1} Green:{2} Blue:{3}", this.d, this.a, this.b, this.c);
	}

	public string a(string A_0)
	{
		if (A_0 == null)
		{
			return ToString();
		}
		return string.Format(CultureInfo.CurrentCulture, "Alpha:{0} Red:{1} Green:{2} Blue:{3}", this.d.ToString(A_0, CultureInfo.CurrentCulture), this.a.ToString(A_0, CultureInfo.CurrentCulture), this.b.ToString(A_0, CultureInfo.CurrentCulture), this.c.ToString(A_0, CultureInfo.CurrentCulture));
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, "Alpha:{0} Red:{1} Green:{2} Blue:{3}", this.d, this.a, this.b, this.c);
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		if (A_0 == null)
		{
			return a(A_1);
		}
		return string.Format(A_1, "Alpha:{0} Red:{1} Green:{2} Blue:{3}", this.d.ToString(A_0, A_1), this.a.ToString(A_0, A_1), this.b.ToString(A_0, A_1), this.c.ToString(A_0, A_1));
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int c()
	{
		return this.d.GetHashCode() + this.a.GetHashCode() + this.b.GetHashCode() + this.c.GetHashCode();
	}

	public bool g(ae A_0)
	{
		if (this.d == A_0.d && this.a == A_0.a && this.b == A_0.b)
		{
			return this.c == A_0.c;
		}
		return false;
	}

	bool IEquatable<ae>.Equals(ae A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in g
		return this.g(A_0);
	}

	public bool a(object A_0)
	{
		if (A_0 == null)
		{
			return false;
		}
		if ((object)A_0.GetType() != GetType())
		{
			return false;
		}
		return g((ae)A_0);
	}
}
