using System;
using System.ComponentModel;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using SharpDX.Design;

namespace SharpDX;

[Serializable]
[StructLayout(LayoutKind.Sequential, Pack = 4)]
[DefaultMember("Item")]
[TypeConverter(typeof(SharpDX.Design.h))]
public struct au : IEquatable<au>, IFormattable
{
	public static readonly int a = Marshal.SizeOf(typeof(au));

	public static readonly au b = default(au);

	public static readonly au c = new au(1f, 0f);

	public static readonly au d = new au(0f, 1f);

	public static readonly au e = new au(1f, 1f);

	public float f;

	public float g;

	public au(float A_0)
	{
		this.f = A_0;
		this.g = A_0;
	}

	public au(float A_0, float A_1)
	{
		this.f = A_0;
		this.g = A_1;
	}

	public au(float[] A_0)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("values");
		}
		if (A_0.Length != 2)
		{
			throw new ArgumentOutOfRangeException("values", "There must be two and only two input values for Vector2.");
		}
		this.f = A_0[0];
		this.g = A_0[1];
	}

	[SpecialName]
	public bool c()
	{
		return Math.Abs(this.f * this.f + this.g * this.g - 1f) < 1E-06f;
	}

	[SpecialName]
	public float a(int A_0)
	{
		return A_0 switch
		{
			0 => this.f, 
			1 => this.g, 
			_ => throw new ArgumentOutOfRangeException("index", "Indices for Vector2 run from 0 to 1, inclusive."), 
		};
	}

	[SpecialName]
	public void a(int A_0, float A_1)
	{
		switch (A_0)
		{
		case 0:
			this.f = A_1;
			break;
		case 1:
			this.g = A_1;
			break;
		default:
			throw new ArgumentOutOfRangeException("index", "Indices for Vector2 run from 0 to 1, inclusive.");
		}
	}

	public float e()
	{
		return (float)Math.Sqrt(this.f * this.f + this.g * this.g);
	}

	public float d()
	{
		return this.f * this.f + this.g * this.g;
	}

	public void a()
	{
		float num = e();
		if (num > 1E-06f)
		{
			float num2 = 1f / num;
			this.f *= num2;
			this.g *= num2;
		}
	}

	public float[] b()
	{
		return new float[2] { this.f, this.g };
	}

	public static void f(ref au A_0, ref au A_1, out au A_2)
	{
		A_2 = new au(A_0.f + A_1.f, A_0.g + A_1.g);
	}

	public static au m(au A_0, au A_1)
	{
		return new au(A_0.f + A_1.f, A_0.g + A_1.g);
	}

	public static void e(ref au A_0, ref au A_1, out au A_2)
	{
		A_2 = new au(A_0.f - A_1.f, A_0.g - A_1.g);
	}

	public static au l(au A_0, au A_1)
	{
		return new au(A_0.f - A_1.f, A_0.g - A_1.g);
	}

	public static void b(ref au A_0, float A_1, out au A_2)
	{
		A_2 = new au(A_0.f * A_1, A_0.g * A_1);
	}

	public static au d(au A_0, float A_1)
	{
		return new au(A_0.f * A_1, A_0.g * A_1);
	}

	public static void d(ref au A_0, ref au A_1, out au A_2)
	{
		A_2 = new au(A_0.f * A_1.f, A_0.g * A_1.g);
	}

	public static au k(au A_0, au A_1)
	{
		return new au(A_0.f * A_1.f, A_0.g * A_1.g);
	}

	public static void a(ref au A_0, float A_1, out au A_2)
	{
		A_2 = new au(A_0.f / A_1, A_0.g / A_1);
	}

	public static au c(au A_0, float A_1)
	{
		return new au(A_0.f / A_1, A_0.g / A_1);
	}

	public static void b(ref au A_0, out au A_1)
	{
		A_1 = new au(0f - A_0.f, 0f - A_0.g);
	}

	public static au f(au A_0)
	{
		return new au(0f - A_0.f, 0f - A_0.g);
	}

	public static void a(ref au A_0, ref au A_1, ref au A_2, float A_3, float A_4, out au A_5)
	{
		A_5 = new au(A_0.f + A_3 * (A_1.f - A_0.f) + A_4 * (A_2.f - A_0.f), A_0.g + A_3 * (A_1.g - A_0.g) + A_4 * (A_2.g - A_0.g));
	}

	public static au a(au A_0, au A_1, au A_2, float A_3, float A_4)
	{
		a(ref A_0, ref A_1, ref A_2, A_3, A_4, out var A_5);
		return A_5;
	}

	public static void a(ref au A_0, ref au A_1, ref au A_2, out au A_3)
	{
		float num = A_0.f;
		num = ((num > A_2.f) ? A_2.f : num);
		num = ((num < A_1.f) ? A_1.f : num);
		float num2 = A_0.g;
		num2 = ((num2 > A_2.g) ? A_2.g : num2);
		num2 = ((num2 < A_1.g) ? A_1.g : num2);
		A_3 = new au(num, num2);
	}

	public static au a(au A_0, au A_1, au A_2)
	{
		a(ref A_0, ref A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void c(ref au A_0, ref au A_1, out float A_2)
	{
		float num = A_0.f - A_1.f;
		float num2 = A_0.g - A_1.g;
		A_2 = (float)Math.Sqrt(num * num + num2 * num2);
	}

	public static float j(au A_0, au A_1)
	{
		float num = A_0.f - A_1.f;
		float num2 = A_0.g - A_1.g;
		return (float)Math.Sqrt(num * num + num2 * num2);
	}

	public static void b(ref au A_0, ref au A_1, out float A_2)
	{
		float num = A_0.f - A_1.f;
		float num2 = A_0.g - A_1.g;
		A_2 = num * num + num2 * num2;
	}

	public static float i(au A_0, au A_1)
	{
		float num = A_0.f - A_1.f;
		float num2 = A_0.g - A_1.g;
		return num * num + num2 * num2;
	}

	public static void a(ref au A_0, ref au A_1, out float A_2)
	{
		A_2 = A_0.f * A_1.f + A_0.g * A_1.g;
	}

	public static float h(au A_0, au A_1)
	{
		return A_0.f * A_1.f + A_0.g * A_1.g;
	}

	public static void a(ref au A_0, out au A_1)
	{
		A_1 = A_0;
		A_1.a();
	}

	public static au e(au A_0)
	{
		A_0.a();
		return A_0;
	}

	public static void b(ref au A_0, ref au A_1, float A_2, out au A_3)
	{
		A_3.f = A_0.f + (A_1.f - A_0.f) * A_2;
		A_3.g = A_0.g + (A_1.g - A_0.g) * A_2;
	}

	public static au b(au A_0, au A_1, float A_2)
	{
		b(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void a(ref au A_0, ref au A_1, float A_2, out au A_3)
	{
		A_2 = ((A_2 > 1f) ? 1f : ((A_2 < 0f) ? 0f : A_2));
		A_2 = A_2 * A_2 * (3f - 2f * A_2);
		A_3.f = A_0.f + (A_1.f - A_0.f) * A_2;
		A_3.g = A_0.g + (A_1.g - A_0.g) * A_2;
	}

	public static au a(au A_0, au A_1, float A_2)
	{
		a(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void b(ref au A_0, ref au A_1, ref au A_2, ref au A_3, float A_4, out au A_5)
	{
		float num = A_4 * A_4;
		float num2 = A_4 * num;
		float num3 = 2f * num2 - 3f * num + 1f;
		float num4 = -2f * num2 + 3f * num;
		float num5 = num2 - 2f * num + A_4;
		float num6 = num2 - num;
		A_5.f = A_0.f * num3 + A_2.f * num4 + A_1.f * num5 + A_3.f * num6;
		A_5.g = A_0.g * num3 + A_2.g * num4 + A_1.g * num5 + A_3.g * num6;
	}

	public static au b(au A_0, au A_1, au A_2, au A_3, float A_4)
	{
		b(ref A_0, ref A_1, ref A_2, ref A_3, A_4, out var A_5);
		return A_5;
	}

	public static void a(ref au A_0, ref au A_1, ref au A_2, ref au A_3, float A_4, out au A_5)
	{
		float num = A_4 * A_4;
		float num2 = A_4 * num;
		A_5.f = 0.5f * (2f * A_1.f + (0f - A_0.f + A_2.f) * A_4 + (2f * A_0.f - 5f * A_1.f + 4f * A_2.f - A_3.f) * num + (0f - A_0.f + 3f * A_1.f - 3f * A_2.f + A_3.f) * num2);
		A_5.g = 0.5f * (2f * A_1.g + (0f - A_0.g + A_2.g) * A_4 + (2f * A_0.g - 5f * A_1.g + 4f * A_2.g - A_3.g) * num + (0f - A_0.g + 3f * A_1.g - 3f * A_2.g + A_3.g) * num2);
	}

	public static au a(au A_0, au A_1, au A_2, au A_3, float A_4)
	{
		a(ref A_0, ref A_1, ref A_2, ref A_3, A_4, out var A_5);
		return A_5;
	}

	public static void c(ref au A_0, ref au A_1, out au A_2)
	{
		A_2.f = ((A_0.f > A_1.f) ? A_0.f : A_1.f);
		A_2.g = ((A_0.g > A_1.g) ? A_0.g : A_1.g);
	}

	public static au g(au A_0, au A_1)
	{
		c(ref A_0, ref A_1, out au A_2);
		return A_2;
	}

	public static void b(ref au A_0, ref au A_1, out au A_2)
	{
		A_2.f = ((A_0.f < A_1.f) ? A_0.f : A_1.f);
		A_2.g = ((A_0.g < A_1.g) ? A_0.g : A_1.g);
	}

	public static au f(au A_0, au A_1)
	{
		b(ref A_0, ref A_1, out au A_2);
		return A_2;
	}

	public static void a(ref au A_0, ref au A_1, out au A_2)
	{
		float num = A_0.f * A_1.f + A_0.g * A_1.g;
		A_2.f = A_0.f - 2f * num * A_1.f;
		A_2.g = A_0.g - 2f * num * A_1.g;
	}

	public static au e(au A_0, au A_1)
	{
		a(ref A_0, ref A_1, out au A_2);
		return A_2;
	}

	public static void b(au[] A_0, params au[] A_1)
	{
		if (A_1 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_0 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_0.Length < A_1.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_1.Length; num++)
		{
			au au2 = A_1[num];
			for (int num2 = 0; num2 < num; num2++)
			{
				au2 = c(au2, a(h(A_0[num2], au2) / h(A_0[num2], A_0[num2]), A_0[num2]));
			}
			A_0[num] = au2;
		}
	}

	public static void a(au[] A_0, params au[] A_1)
	{
		if (A_1 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_0 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_0.Length < A_1.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_1.Length; num++)
		{
			au au2 = A_1[num];
			for (int num2 = 0; num2 < num; num2++)
			{
				au2 = c(au2, a(h(A_0[num2], au2), A_0[num2]));
			}
			au2.a();
			A_0[num] = au2;
		}
	}

	public static void a(ref au A_0, ref v A_1, out au A_2)
	{
		float num = A_1.e + A_1.e;
		float num2 = A_1.f + A_1.f;
		float num3 = A_1.g + A_1.g;
		float num4 = A_1.h * num3;
		float num5 = A_1.e * num;
		float num6 = A_1.e * num2;
		float num7 = A_1.f * num2;
		float num8 = A_1.g * num3;
		A_2 = new au(A_0.f * (1f - num7 - num8) + A_0.g * (num6 - num4), A_0.f * (num6 + num4) + A_0.g * (1f - num5 - num8));
	}

	public static au a(au A_0, v A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(au[] A_0, ref v A_1, au[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		float num = A_1.e + A_1.e;
		float num2 = A_1.f + A_1.f;
		float num3 = A_1.g + A_1.g;
		float num4 = A_1.h * num3;
		float num5 = A_1.e * num;
		float num6 = A_1.e * num2;
		float num7 = A_1.f * num2;
		float num8 = A_1.g * num3;
		float num9 = 1f - num7 - num8;
		float num10 = num6 - num4;
		float num11 = num6 + num4;
		float num12 = 1f - num5 - num8;
		for (int num13 = 0; num13 < A_0.Length; num13++)
		{
			ref au reference = ref A_2[num13];
			reference = new au(A_0[num13].f * num9 + A_0[num13].g * num10, A_0[num13].f * num11 + A_0[num13].g * num12);
		}
	}

	public static void a(ref au A_0, ref q A_1, out i A_2)
	{
		A_2 = new i(A_0.f * A_1.d + A_0.g * A_1.h + A_1.p, A_0.f * A_1.e + A_0.g * A_1.i + A_1.q, A_0.f * A_1.f + A_0.g * A_1.j + A_1.r, A_0.f * A_1.g + A_0.g * A_1.k + A_1.s);
	}

	public static i c(au A_0, q A_1)
	{
		a(ref A_0, ref A_1, out i A_2);
		return A_2;
	}

	public static void a(au[] A_0, ref q A_1, i[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_0.Length; num++)
		{
			a(ref A_0[num], ref A_1, out A_2[num]);
		}
	}

	public static void b(ref au A_0, ref q A_1, out au A_2)
	{
		i i2 = default(i);
		i2.h = A_0.f * A_1.d + A_0.g * A_1.h + A_1.p;
		i2.i = A_0.f * A_1.e + A_0.g * A_1.i + A_1.q;
		i2.j = A_0.f * A_1.f + A_0.g * A_1.j + A_1.r;
		i2.k = 1f / (A_0.f * A_1.g + A_0.g * A_1.k + A_1.s);
		A_2 = new au(i2.h * i2.k, i2.i * i2.k);
	}

	public static au b(au A_0, q A_1)
	{
		b(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void b(au[] A_0, ref q A_1, au[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_0.Length; num++)
		{
			b(ref A_0[num], ref A_1, out A_2[num]);
		}
	}

	public static void a(ref au A_0, ref q A_1, out au A_2)
	{
		A_2 = new au(A_0.f * A_1.d + A_0.g * A_1.h, A_0.f * A_1.e + A_0.g * A_1.i);
	}

	public static au a(au A_0, q A_1)
	{
		a(ref A_0, ref A_1, out au A_2);
		return A_2;
	}

	public static void a(au[] A_0, ref q A_1, au[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_0.Length; num++)
		{
			a(ref A_0[num], ref A_1, out A_2[num]);
		}
	}

	[SpecialName]
	public static au d(au A_0, au A_1)
	{
		return new au(A_0.f + A_1.f, A_0.g + A_1.g);
	}

	[SpecialName]
	public static au d(au A_0)
	{
		return A_0;
	}

	[SpecialName]
	public static au c(au A_0, au A_1)
	{
		return new au(A_0.f - A_1.f, A_0.g - A_1.g);
	}

	[SpecialName]
	public static au c(au A_0)
	{
		return new au(0f - A_0.f, 0f - A_0.g);
	}

	[SpecialName]
	public static au a(float A_0, au A_1)
	{
		return new au(A_1.f * A_0, A_1.g * A_0);
	}

	[SpecialName]
	public static au b(au A_0, float A_1)
	{
		return new au(A_0.f * A_1, A_0.g * A_1);
	}

	[SpecialName]
	public static au a(au A_0, float A_1)
	{
		return new au(A_0.f / A_1, A_0.g / A_1);
	}

	[SpecialName]
	public static bool b(au A_0, au A_1)
	{
		return A_0.g(A_1);
	}

	[SpecialName]
	public static bool a(au A_0, au A_1)
	{
		return !A_0.g(A_1);
	}

	[SpecialName]
	public static a b(au A_0)
	{
		return new a(A_0, 0f);
	}

	[SpecialName]
	public static i a(au A_0)
	{
		return new i(A_0, 0f, 0f);
	}

	public string g()
	{
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1}", new object[2] { this.f, this.g });
	}

	public string a(string A_0)
	{
		if (A_0 == null)
		{
			return ToString();
		}
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1}", new object[2]
		{
			this.f.ToString(A_0, CultureInfo.CurrentCulture),
			this.g.ToString(A_0, CultureInfo.CurrentCulture)
		});
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, "X:{0} Y:{1}", new object[2] { this.f, this.g });
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		if (A_0 == null)
		{
			a(A_1);
		}
		return string.Format(A_1, "X:{0} Y:{1}", new object[2]
		{
			this.f.ToString(A_0, A_1),
			this.g.ToString(A_0, A_1)
		});
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int f()
	{
		return this.f.GetHashCode() + this.g.GetHashCode();
	}

	public bool g(au A_0)
	{
		if (Math.Abs(A_0.f - this.f) < 1E-06f)
		{
			return Math.Abs(A_0.g - this.g) < 1E-06f;
		}
		return false;
	}

	bool IEquatable<au>.Equals(au A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in g
		return this.g(A_0);
	}

	public bool a(object A_0)
	{
		if (A_0 == null)
		{
			return false;
		}
		if ((object)A_0.GetType() != GetType())
		{
			return false;
		}
		return g((au)A_0);
	}
}
