using System;
using System.ComponentModel;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using SharpDX.Design;

namespace SharpDX;

[Serializable]
[StructLayout(LayoutKind.Sequential, Pack = 4)]
[TypeConverter(typeof(SharpDX.Design.f))]
[DefaultMember("Item")]
public struct i : IEquatable<i>, IFormattable
{
	public static readonly int a = Marshal.SizeOf(typeof(i));

	public static readonly i b = default(i);

	public static readonly i c = new i(1f, 0f, 0f, 0f);

	public static readonly i d = new i(0f, 1f, 0f, 0f);

	public static readonly i e = new i(0f, 0f, 1f, 0f);

	public static readonly i f = new i(0f, 0f, 0f, 1f);

	public static readonly i g = new i(1f, 1f, 1f, 1f);

	public float h;

	public float i;

	public float j;

	public float k;

	public i(float A_0)
	{
		this.h = A_0;
		this.i = A_0;
		this.j = A_0;
		this.k = A_0;
	}

	public i(float A_0, float A_1, float A_2, float A_3)
	{
		this.h = A_0;
		this.i = A_1;
		this.j = A_2;
		this.k = A_3;
	}

	public i(a A_0, float A_1)
	{
		this.h = A_0.g;
		this.i = A_0.h;
		this.j = A_0.i;
		this.k = A_1;
	}

	public i(au A_0, float A_1, float A_2)
	{
		this.h = A_0.f;
		this.i = A_0.g;
		this.j = A_1;
		this.k = A_2;
	}

	public i(float[] A_0)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("values");
		}
		if (A_0.Length != 4)
		{
			throw new ArgumentOutOfRangeException("values", "There must be four and only four input values for Vector4.");
		}
		this.h = A_0[0];
		this.i = A_0[1];
		this.j = A_0[2];
		this.k = A_0[3];
	}

	[SpecialName]
	public bool c()
	{
		return Math.Abs(this.h * this.h + this.i * this.i + this.j * this.j + this.k * this.k - 1f) < 1E-06f;
	}

	[SpecialName]
	public float a(int A_0)
	{
		return A_0 switch
		{
			0 => this.h, 
			1 => this.i, 
			2 => this.j, 
			3 => this.k, 
			_ => throw new ArgumentOutOfRangeException("index", "Indices for Vector4 run from 0 to 3, inclusive."), 
		};
	}

	[SpecialName]
	public void a(int A_0, float A_1)
	{
		switch (A_0)
		{
		case 0:
			this.h = A_1;
			break;
		case 1:
			this.i = A_1;
			break;
		case 2:
			this.j = A_1;
			break;
		case 3:
			this.k = A_1;
			break;
		default:
			throw new ArgumentOutOfRangeException("index", "Indices for Vector4 run from 0 to 3, inclusive.");
		}
	}

	public float e()
	{
		return (float)Math.Sqrt(this.h * this.h + this.i * this.i + this.j * this.j + this.k * this.k);
	}

	public float d()
	{
		return this.h * this.h + this.i * this.i + this.j * this.j + this.k * this.k;
	}

	public void a()
	{
		float num = e();
		if (num > 1E-06f)
		{
			float num2 = 1f / num;
			this.h *= num2;
			this.i *= num2;
			this.j *= num2;
			this.k *= num2;
		}
	}

	public float[] b()
	{
		return new float[4] { this.h, this.i, this.j, this.k };
	}

	public static void e(ref i A_0, ref i A_1, out i A_2)
	{
		A_2 = new i(A_0.h + A_1.h, A_0.i + A_1.i, A_0.j + A_1.j, A_0.k + A_1.k);
	}

	public static i l(i A_0, i A_1)
	{
		return new i(A_0.h + A_1.h, A_0.i + A_1.i, A_0.j + A_1.j, A_0.k + A_1.k);
	}

	public static void d(ref i A_0, ref i A_1, out i A_2)
	{
		A_2 = new i(A_0.h - A_1.h, A_0.i - A_1.i, A_0.j - A_1.j, A_0.k - A_1.k);
	}

	public static i k(i A_0, i A_1)
	{
		return new i(A_0.h - A_1.h, A_0.i - A_1.i, A_0.j - A_1.j, A_0.k - A_1.k);
	}

	public static void b(ref i A_0, float A_1, out i A_2)
	{
		A_2 = new i(A_0.h * A_1, A_0.i * A_1, A_0.j * A_1, A_0.k * A_1);
	}

	public static i d(i A_0, float A_1)
	{
		return new i(A_0.h * A_1, A_0.i * A_1, A_0.j * A_1, A_0.k * A_1);
	}

	public static void c(ref i A_0, ref i A_1, out i A_2)
	{
		A_2 = new i(A_0.h * A_1.h, A_0.i * A_1.i, A_0.j * A_1.j, A_0.k * A_1.k);
	}

	public static i j(i A_0, i A_1)
	{
		return new i(A_0.h * A_1.h, A_0.i * A_1.i, A_0.j * A_1.j, A_0.k * A_1.k);
	}

	public static void a(ref i A_0, float A_1, out i A_2)
	{
		A_2 = new i(A_0.h / A_1, A_0.i / A_1, A_0.j / A_1, A_0.k / A_1);
	}

	public static i c(i A_0, float A_1)
	{
		return new i(A_0.h / A_1, A_0.i / A_1, A_0.j / A_1, A_0.k / A_1);
	}

	public static void b(ref i A_0, out i A_1)
	{
		A_1 = new i(0f - A_0.h, 0f - A_0.i, 0f - A_0.j, 0f - A_0.k);
	}

	public static i f(i A_0)
	{
		return new i(0f - A_0.h, 0f - A_0.i, 0f - A_0.j, 0f - A_0.k);
	}

	public static void a(ref i A_0, ref i A_1, ref i A_2, float A_3, float A_4, out i A_5)
	{
		A_5 = new i(A_0.h + A_3 * (A_1.h - A_0.h) + A_4 * (A_2.h - A_0.h), A_0.i + A_3 * (A_1.i - A_0.i) + A_4 * (A_2.i - A_0.i), A_0.j + A_3 * (A_1.j - A_0.j) + A_4 * (A_2.j - A_0.j), A_0.k + A_3 * (A_1.k - A_0.k) + A_4 * (A_2.k - A_0.k));
	}

	public static i a(i A_0, i A_1, i A_2, float A_3, float A_4)
	{
		a(ref A_0, ref A_1, ref A_2, A_3, A_4, out var A_5);
		return A_5;
	}

	public static void a(ref i A_0, ref i A_1, ref i A_2, out i A_3)
	{
		float num = A_0.h;
		num = ((num > A_2.h) ? A_2.h : num);
		num = ((num < A_1.h) ? A_1.h : num);
		float num2 = A_0.i;
		num2 = ((num2 > A_2.i) ? A_2.i : num2);
		num2 = ((num2 < A_1.i) ? A_1.i : num2);
		float num3 = A_0.j;
		num3 = ((num3 > A_2.j) ? A_2.j : num3);
		num3 = ((num3 < A_1.j) ? A_1.j : num3);
		float num4 = A_0.k;
		num4 = ((num4 > A_2.k) ? A_2.k : num4);
		num4 = ((num4 < A_1.k) ? A_1.k : num4);
		A_3 = new i(num, num2, num3, num4);
	}

	public static i a(i A_0, i A_1, i A_2)
	{
		a(ref A_0, ref A_1, ref A_2, out var A_3);
		return A_3;
	}

	public static void c(ref i A_0, ref i A_1, out float A_2)
	{
		float num = A_0.h - A_1.h;
		float num2 = A_0.i - A_1.i;
		float num3 = A_0.j - A_1.j;
		float num4 = A_0.k - A_1.k;
		A_2 = (float)Math.Sqrt(num * num + num2 * num2 + num3 * num3 + num4 * num4);
	}

	public static float i(i A_0, i A_1)
	{
		float num = A_0.h - A_1.h;
		float num2 = A_0.i - A_1.i;
		float num3 = A_0.j - A_1.j;
		float num4 = A_0.k - A_1.k;
		return (float)Math.Sqrt(num * num + num2 * num2 + num3 * num3 + num4 * num4);
	}

	public static void b(ref i A_0, ref i A_1, out float A_2)
	{
		float num = A_0.h - A_1.h;
		float num2 = A_0.i - A_1.i;
		float num3 = A_0.j - A_1.j;
		float num4 = A_0.k - A_1.k;
		A_2 = num * num + num2 * num2 + num3 * num3 + num4 * num4;
	}

	public static float h(i A_0, i A_1)
	{
		float num = A_0.h - A_1.h;
		float num2 = A_0.i - A_1.i;
		float num3 = A_0.j - A_1.j;
		float num4 = A_0.k - A_1.k;
		return num * num + num2 * num2 + num3 * num3 + num4 * num4;
	}

	public static void a(ref i A_0, ref i A_1, out float A_2)
	{
		A_2 = A_0.h * A_1.h + A_0.i * A_1.i + A_0.j * A_1.j + A_0.k * A_1.k;
	}

	public static float g(i A_0, i A_1)
	{
		return A_0.h * A_1.h + A_0.i * A_1.i + A_0.j * A_1.j + A_0.k * A_1.k;
	}

	public static void a(ref i A_0, out i A_1)
	{
		i i2 = A_0;
		A_1 = i2;
		A_1.a();
	}

	public static i e(i A_0)
	{
		A_0.a();
		return A_0;
	}

	public static void b(ref i A_0, ref i A_1, float A_2, out i A_3)
	{
		A_3.h = A_0.h + (A_1.h - A_0.h) * A_2;
		A_3.i = A_0.i + (A_1.i - A_0.i) * A_2;
		A_3.j = A_0.j + (A_1.j - A_0.j) * A_2;
		A_3.k = A_0.k + (A_1.k - A_0.k) * A_2;
	}

	public static i b(i A_0, i A_1, float A_2)
	{
		b(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void a(ref i A_0, ref i A_1, float A_2, out i A_3)
	{
		A_2 = ((A_2 > 1f) ? 1f : ((A_2 < 0f) ? 0f : A_2));
		A_2 = A_2 * A_2 * (3f - 2f * A_2);
		A_3.h = A_0.h + (A_1.h - A_0.h) * A_2;
		A_3.i = A_0.i + (A_1.i - A_0.i) * A_2;
		A_3.j = A_0.j + (A_1.j - A_0.j) * A_2;
		A_3.k = A_0.k + (A_1.k - A_0.k) * A_2;
	}

	public static i a(i A_0, i A_1, float A_2)
	{
		a(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void b(ref i A_0, ref i A_1, ref i A_2, ref i A_3, float A_4, out i A_5)
	{
		float num = A_4 * A_4;
		float num2 = A_4 * num;
		float num3 = 2f * num2 - 3f * num + 1f;
		float num4 = -2f * num2 + 3f * num;
		float num5 = num2 - 2f * num + A_4;
		float num6 = num2 - num;
		A_5 = new i(A_0.h * num3 + A_2.h * num4 + A_1.h * num5 + A_3.h * num6, A_0.i * num3 + A_2.i * num4 + A_1.i * num5 + A_3.i * num6, A_0.j * num3 + A_2.j * num4 + A_1.j * num5 + A_3.j * num6, A_0.k * num3 + A_2.k * num4 + A_1.k * num5 + A_3.k * num6);
	}

	public static i b(i A_0, i A_1, i A_2, i A_3, float A_4)
	{
		b(ref A_0, ref A_1, ref A_2, ref A_3, A_4, out var A_5);
		return A_5;
	}

	public static void a(ref i A_0, ref i A_1, ref i A_2, ref i A_3, float A_4, out i A_5)
	{
		float num = A_4 * A_4;
		float num2 = A_4 * num;
		A_5.h = 0.5f * (2f * A_1.h + (0f - A_0.h + A_2.h) * A_4 + (2f * A_0.h - 5f * A_1.h + 4f * A_2.h - A_3.h) * num + (0f - A_0.h + 3f * A_1.h - 3f * A_2.h + A_3.h) * num2);
		A_5.i = 0.5f * (2f * A_1.i + (0f - A_0.i + A_2.i) * A_4 + (2f * A_0.i - 5f * A_1.i + 4f * A_2.i - A_3.i) * num + (0f - A_0.i + 3f * A_1.i - 3f * A_2.i + A_3.i) * num2);
		A_5.j = 0.5f * (2f * A_1.j + (0f - A_0.j + A_2.j) * A_4 + (2f * A_0.j - 5f * A_1.j + 4f * A_2.j - A_3.j) * num + (0f - A_0.j + 3f * A_1.j - 3f * A_2.j + A_3.j) * num2);
		A_5.k = 0.5f * (2f * A_1.k + (0f - A_0.k + A_2.k) * A_4 + (2f * A_0.k - 5f * A_1.k + 4f * A_2.k - A_3.k) * num + (0f - A_0.k + 3f * A_1.k - 3f * A_2.k + A_3.k) * num2);
	}

	public static i a(i A_0, i A_1, i A_2, i A_3, float A_4)
	{
		a(ref A_0, ref A_1, ref A_2, ref A_3, A_4, out var A_5);
		return A_5;
	}

	public static void b(ref i A_0, ref i A_1, out i A_2)
	{
		A_2.h = ((A_0.h > A_1.h) ? A_0.h : A_1.h);
		A_2.i = ((A_0.i > A_1.i) ? A_0.i : A_1.i);
		A_2.j = ((A_0.j > A_1.j) ? A_0.j : A_1.j);
		A_2.k = ((A_0.k > A_1.k) ? A_0.k : A_1.k);
	}

	public static i f(i A_0, i A_1)
	{
		b(ref A_0, ref A_1, out i A_2);
		return A_2;
	}

	public static void a(ref i A_0, ref i A_1, out i A_2)
	{
		A_2.h = ((A_0.h < A_1.h) ? A_0.h : A_1.h);
		A_2.i = ((A_0.i < A_1.i) ? A_0.i : A_1.i);
		A_2.j = ((A_0.j < A_1.j) ? A_0.j : A_1.j);
		A_2.k = ((A_0.k < A_1.k) ? A_0.k : A_1.k);
	}

	public static i e(i A_0, i A_1)
	{
		a(ref A_0, ref A_1, out i A_2);
		return A_2;
	}

	public static void b(i[] A_0, params i[] A_1)
	{
		if (A_1 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_0 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_0.Length < A_1.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_1.Length; num++)
		{
			i i2 = A_1[num];
			for (int num2 = 0; num2 < num; num2++)
			{
				i2 = c(i2, a(g(A_0[num2], i2) / g(A_0[num2], A_0[num2]), A_0[num2]));
			}
			A_0[num] = i2;
		}
	}

	public static void a(i[] A_0, params i[] A_1)
	{
		if (A_1 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_0 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_0.Length < A_1.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_1.Length; num++)
		{
			i i2 = A_1[num];
			for (int num2 = 0; num2 < num; num2++)
			{
				i2 = c(i2, a(g(A_0[num2], i2), A_0[num2]));
			}
			i2.a();
			A_0[num] = i2;
		}
	}

	public static void a(ref i A_0, ref v A_1, out i A_2)
	{
		float num = A_1.e + A_1.e;
		float num2 = A_1.f + A_1.f;
		float num3 = A_1.g + A_1.g;
		float num4 = A_1.h * num;
		float num5 = A_1.h * num2;
		float num6 = A_1.h * num3;
		float num7 = A_1.e * num;
		float num8 = A_1.e * num2;
		float num9 = A_1.e * num3;
		float num10 = A_1.f * num2;
		float num11 = A_1.f * num3;
		float num12 = A_1.g * num3;
		A_2 = new i(A_0.h * (1f - num10 - num12) + A_0.i * (num8 - num6) + A_0.j * (num9 + num5), A_0.h * (num8 + num6) + A_0.i * (1f - num7 - num12) + A_0.j * (num11 - num4), A_0.h * (num9 - num5) + A_0.i * (num11 + num4) + A_0.j * (1f - num7 - num10), A_0.k);
	}

	public static i a(i A_0, v A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(i[] A_0, ref v A_1, i[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		float num = A_1.e + A_1.e;
		float num2 = A_1.f + A_1.f;
		float num3 = A_1.g + A_1.g;
		float num4 = A_1.h * num;
		float num5 = A_1.h * num2;
		float num6 = A_1.h * num3;
		float num7 = A_1.e * num;
		float num8 = A_1.e * num2;
		float num9 = A_1.e * num3;
		float num10 = A_1.f * num2;
		float num11 = A_1.f * num3;
		float num12 = A_1.g * num3;
		float num13 = 1f - num10 - num12;
		float num14 = num8 - num6;
		float num15 = num9 + num5;
		float num16 = num8 + num6;
		float num17 = 1f - num7 - num12;
		float num18 = num11 - num4;
		float num19 = num9 - num5;
		float num20 = num11 + num4;
		float num21 = 1f - num7 - num10;
		for (int num22 = 0; num22 < A_0.Length; num22++)
		{
			ref i reference = ref A_2[num22];
			reference = new i(A_0[num22].h * num13 + A_0[num22].i * num14 + A_0[num22].j * num15, A_0[num22].h * num16 + A_0[num22].i * num17 + A_0[num22].j * num18, A_0[num22].h * num19 + A_0[num22].i * num20 + A_0[num22].j * num21, A_0[num22].k);
		}
	}

	public static void a(ref i A_0, ref q A_1, out i A_2)
	{
		A_2 = new i(A_0.h * A_1.d + A_0.i * A_1.h + A_0.j * A_1.l + A_0.k * A_1.p, A_0.h * A_1.e + A_0.i * A_1.i + A_0.j * A_1.m + A_0.k * A_1.q, A_0.h * A_1.f + A_0.i * A_1.j + A_0.j * A_1.n + A_0.k * A_1.r, A_0.h * A_1.g + A_0.i * A_1.k + A_0.j * A_1.o + A_0.k * A_1.s);
	}

	public static i a(i A_0, q A_1)
	{
		a(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(i[] A_0, ref q A_1, i[] A_2)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("source");
		}
		if (A_2 == null)
		{
			throw new ArgumentNullException("destination");
		}
		if (A_2.Length < A_0.Length)
		{
			throw new ArgumentOutOfRangeException("destination", "The destination array must be of same length or larger length than the source array.");
		}
		for (int num = 0; num < A_0.Length; num++)
		{
			a(ref A_0[num], ref A_1, out A_2[num]);
		}
	}

	[SpecialName]
	public static i d(i A_0, i A_1)
	{
		return new i(A_0.h + A_1.h, A_0.i + A_1.i, A_0.j + A_1.j, A_0.k + A_1.k);
	}

	[SpecialName]
	public static i d(i A_0)
	{
		return A_0;
	}

	[SpecialName]
	public static i c(i A_0, i A_1)
	{
		return new i(A_0.h - A_1.h, A_0.i - A_1.i, A_0.j - A_1.j, A_0.k - A_1.k);
	}

	[SpecialName]
	public static i c(i A_0)
	{
		return new i(0f - A_0.h, 0f - A_0.i, 0f - A_0.j, 0f - A_0.k);
	}

	[SpecialName]
	public static i a(float A_0, i A_1)
	{
		return new i(A_1.h * A_0, A_1.i * A_0, A_1.j * A_0, A_1.k * A_0);
	}

	[SpecialName]
	public static i b(i A_0, float A_1)
	{
		return new i(A_0.h * A_1, A_0.i * A_1, A_0.j * A_1, A_0.k * A_1);
	}

	[SpecialName]
	public static i a(i A_0, float A_1)
	{
		return new i(A_0.h / A_1, A_0.i / A_1, A_0.j / A_1, A_0.k / A_1);
	}

	[SpecialName]
	public static bool b(i A_0, i A_1)
	{
		return A_0.g(A_1);
	}

	[SpecialName]
	public static bool a(i A_0, i A_1)
	{
		return !A_0.g(A_1);
	}

	[SpecialName]
	public static au b(i A_0)
	{
		return new au(A_0.h, A_0.i);
	}

	[SpecialName]
	public static a a(i A_0)
	{
		return new a(A_0.h, A_0.i, A_0.j);
	}

	public string g()
	{
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1} Z:{2} W:{3}", this.h, this.i, this.j, this.k);
	}

	public string a(string A_0)
	{
		if (A_0 == null)
		{
			return ToString();
		}
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1} Z:{2} W:{3}", this.h.ToString(A_0, CultureInfo.CurrentCulture), this.i.ToString(A_0, CultureInfo.CurrentCulture), this.j.ToString(A_0, CultureInfo.CurrentCulture), this.k.ToString(A_0, CultureInfo.CurrentCulture));
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, "X:{0} Y:{1} Z:{2} W:{3}", this.h, this.i, this.j, this.k);
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		if (A_0 == null)
		{
			a(A_1);
		}
		return string.Format(A_1, "X:{0} Y:{1} Z:{2} W:{3}", this.h.ToString(A_0, A_1), this.i.ToString(A_0, A_1), this.j.ToString(A_0, A_1), this.k.ToString(A_0, A_1));
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int f()
	{
		return this.h.GetHashCode() + this.i.GetHashCode() + this.j.GetHashCode() + this.k.GetHashCode();
	}

	public bool g(i A_0)
	{
		if (Math.Abs(A_0.h - this.h) < 1E-06f && Math.Abs(A_0.i - this.i) < 1E-06f && Math.Abs(A_0.j - this.j) < 1E-06f)
		{
			return Math.Abs(A_0.k - this.k) < 1E-06f;
		}
		return false;
	}

	bool IEquatable<i>.Equals(i A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in g
		return this.g(A_0);
	}

	public bool a(object A_0)
	{
		if (A_0 == null)
		{
			return false;
		}
		if ((object)A_0.GetType() != GetType())
		{
			return false;
		}
		return g((i)A_0);
	}
}
