using System;
using System.ComponentModel;
using System.Globalization;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using SharpDX.Design;

namespace SharpDX;

[Serializable]
[StructLayout(LayoutKind.Sequential, Pack = 4)]
[DefaultMember("Item")]
[TypeConverter(typeof(SharpDX.Design.i))]
public struct v : IEquatable<v>, IFormattable
{
	public static readonly int a = Marshal.SizeOf(typeof(v));

	public static readonly v b = default(v);

	public static readonly v c = new v(1f, 1f, 1f, 1f);

	public static readonly v d = new v(0f, 0f, 0f, 1f);

	public float e;

	public float f;

	public float g;

	public float h;

	public v(float A_0)
	{
		this.e = A_0;
		this.f = A_0;
		this.g = A_0;
		this.h = A_0;
	}

	public v(i A_0)
	{
		this.e = A_0.h;
		this.f = A_0.i;
		this.g = A_0.j;
		this.h = A_0.k;
	}

	public v(a A_0, float A_1)
	{
		this.e = A_0.g;
		this.f = A_0.h;
		this.g = A_0.i;
		this.h = A_1;
	}

	public v(au A_0, float A_1, float A_2)
	{
		this.e = A_0.f;
		this.f = A_0.g;
		this.g = A_1;
		this.h = A_2;
	}

	public v(float A_0, float A_1, float A_2, float A_3)
	{
		this.e = A_0;
		this.f = A_1;
		this.g = A_2;
		this.h = A_3;
	}

	public v(float[] A_0)
	{
		if (A_0 == null)
		{
			throw new ArgumentNullException("values");
		}
		if (A_0.Length != 4)
		{
			throw new ArgumentOutOfRangeException("values", "There must be four and only four input values for Quaternion.");
		}
		this.e = A_0[0];
		this.f = A_0[1];
		this.g = A_0[2];
		this.h = A_0[3];
	}

	[SpecialName]
	public bool a()
	{
		return h(v.d);
	}

	[SpecialName]
	public bool b()
	{
		return Math.Abs(this.e * this.e + this.f * this.f + this.g * this.g + this.h * this.h - 1f) < 1E-06f;
	}

	[SpecialName]
	public float l()
	{
		float num = this.e * this.e + this.f * this.f + this.g * this.g;
		if (num < 1E-06f)
		{
			return 0f;
		}
		return (float)(2.0 * Math.Acos(this.h));
	}

	[SpecialName]
	public a h()
	{
		float num = this.e * this.e + this.f * this.f + this.g * this.g;
		if (num < 1E-06f)
		{
			return SharpDX.a.c;
		}
		float num2 = 1f / num;
		return new a(this.e * num2, this.f * num2, this.g * num2);
	}

	[SpecialName]
	public float a(int A_0)
	{
		return A_0 switch
		{
			0 => this.e, 
			1 => this.f, 
			2 => this.g, 
			3 => this.h, 
			_ => throw new ArgumentOutOfRangeException("index", "Indices for Quaternion run from 0 to 3, inclusive."), 
		};
	}

	[SpecialName]
	public void a(int A_0, float A_1)
	{
		switch (A_0)
		{
		case 0:
			this.e = A_1;
			break;
		case 1:
			this.f = A_1;
			break;
		case 2:
			this.g = A_1;
			break;
		case 3:
			this.h = A_1;
			break;
		default:
			throw new ArgumentOutOfRangeException("index", "Indices for Quaternion run from 0 to 3, inclusive.");
		}
	}

	public void d()
	{
		this.e = 0f - this.e;
		this.f = 0f - this.f;
		this.g = 0f - this.g;
	}

	public void k()
	{
		float num = c();
		if (num > 1E-06f)
		{
			num = 1f / num;
			this.e = (0f - this.e) * num;
			this.f = (0f - this.f) * num;
			this.g = (0f - this.g) * num;
			this.h *= num;
		}
	}

	public float i()
	{
		return (float)Math.Sqrt(this.e * this.e + this.f * this.f + this.g * this.g + this.h * this.h);
	}

	public float c()
	{
		return this.e * this.e + this.f * this.f + this.g * this.g + this.h * this.h;
	}

	public void e()
	{
		float num = i();
		if (num > 1E-06f)
		{
			float num2 = 1f / num;
			this.e *= num2;
			this.f *= num2;
			this.g *= num2;
			this.h *= num2;
		}
	}

	public float[] j()
	{
		return new float[4] { this.e, this.f, this.g, this.h };
	}

	public static void c(ref v A_0, ref v A_1, out v A_2)
	{
		A_2.e = A_0.e + A_1.e;
		A_2.f = A_0.f + A_1.f;
		A_2.g = A_0.g + A_1.g;
		A_2.h = A_0.h + A_1.h;
	}

	public static v i(v A_0, v A_1)
	{
		c(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void b(ref v A_0, ref v A_1, out v A_2)
	{
		A_2.e = A_0.e - A_1.e;
		A_2.f = A_0.f - A_1.f;
		A_2.g = A_0.g - A_1.g;
		A_2.h = A_0.h - A_1.h;
	}

	public static v h(v A_0, v A_1)
	{
		b(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	public static void a(ref v A_0, float A_1, out v A_2)
	{
		A_2.e = A_0.e * A_1;
		A_2.f = A_0.f * A_1;
		A_2.g = A_0.g * A_1;
		A_2.h = A_0.h * A_1;
	}

	public static v b(v A_0, float A_1)
	{
		a(ref A_0, A_1, out var A_2);
		return A_2;
	}

	public static void a(ref v A_0, ref v A_1, out v A_2)
	{
		float num = A_0.e;
		float num2 = A_0.f;
		float num3 = A_0.g;
		float num4 = A_0.h;
		float num5 = A_1.e;
		float num6 = A_1.f;
		float num7 = A_1.g;
		float num8 = A_1.h;
		A_2.e = num5 * num4 + num * num8 + num6 * num3 - num7 * num2;
		A_2.f = num6 * num4 + num2 * num8 + num7 * num - num5 * num3;
		A_2.g = num7 * num4 + num3 * num8 + num5 * num2 - num6 * num;
		A_2.h = num8 * num4 - (num5 * num + num6 * num2 + num7 * num3);
	}

	public static v g(v A_0, v A_1)
	{
		a(ref A_0, ref A_1, out v A_2);
		return A_2;
	}

	public static void f(ref v A_0, out v A_1)
	{
		A_1.e = 0f - A_0.e;
		A_1.f = 0f - A_0.f;
		A_1.g = 0f - A_0.g;
		A_1.h = 0f - A_0.h;
	}

	public static v g(v A_0)
	{
		f(ref A_0, out var A_1);
		return A_1;
	}

	public static void a(ref v A_0, ref v A_1, ref v A_2, float A_3, float A_4, out v A_5)
	{
		a(ref A_0, ref A_1, A_3 + A_4, out var A_6);
		a(ref A_0, ref A_2, A_3 + A_4, out var A_7);
		a(ref A_6, ref A_7, A_4 / (A_3 + A_4), out A_5);
	}

	public static v a(v A_0, v A_1, v A_2, float A_3, float A_4)
	{
		a(ref A_0, ref A_1, ref A_2, A_3, A_4, out var A_5);
		return A_5;
	}

	public static void e(ref v A_0, out v A_1)
	{
		A_1.e = 0f - A_0.e;
		A_1.f = 0f - A_0.f;
		A_1.g = 0f - A_0.g;
		A_1.h = A_0.h;
	}

	public static v f(v A_0)
	{
		e(ref A_0, out var A_1);
		return A_1;
	}

	public static void a(ref v A_0, ref v A_1, out float A_2)
	{
		A_2 = A_0.e * A_1.e + A_0.f * A_1.f + A_0.g * A_1.g + A_0.h * A_1.h;
	}

	public static float f(v A_0, v A_1)
	{
		return A_0.e * A_1.e + A_0.f * A_1.f + A_0.g * A_1.g + A_0.h * A_1.h;
	}

	public static void d(ref v A_0, out v A_1)
	{
		float num = (float)Math.Sqrt(A_0.e * A_0.e + A_0.f * A_0.f + A_0.g * A_0.g);
		float num2 = (float)Math.Sin(num);
		if (Math.Abs(num2) >= 1E-06f)
		{
			float num3 = num2 / num;
			A_1.e = num3 * A_0.e;
			A_1.f = num3 * A_0.f;
			A_1.g = num3 * A_0.g;
		}
		else
		{
			A_1 = A_0;
		}
		A_1.h = (float)Math.Cos(num);
	}

	public static v e(v A_0)
	{
		d(ref A_0, out var A_1);
		return A_1;
	}

	public static void c(ref v A_0, out v A_1)
	{
		A_1 = A_0;
		A_1.k();
	}

	public static v d(v A_0)
	{
		c(ref A_0, out var A_1);
		return A_1;
	}

	public static void b(ref v A_0, ref v A_1, float A_2, out v A_3)
	{
		float num = 1f - A_2;
		if (f(A_0, A_1) >= 0f)
		{
			A_3.e = num * A_0.e + A_2 * A_1.e;
			A_3.f = num * A_0.f + A_2 * A_1.f;
			A_3.g = num * A_0.g + A_2 * A_1.g;
			A_3.h = num * A_0.h + A_2 * A_1.h;
		}
		else
		{
			A_3.e = num * A_0.e - A_2 * A_1.e;
			A_3.f = num * A_0.f - A_2 * A_1.f;
			A_3.g = num * A_0.g - A_2 * A_1.g;
			A_3.h = num * A_0.h - A_2 * A_1.h;
		}
		A_3.e();
	}

	public static v b(v A_0, v A_1, float A_2)
	{
		b(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void b(ref v A_0, out v A_1)
	{
		if ((double)Math.Abs(A_0.h) < 1.0)
		{
			float num = (float)Math.Acos(A_0.h);
			float num2 = (float)Math.Sin(num);
			if (Math.Abs(num2) >= 1E-06f)
			{
				float num3 = num / num2;
				A_1.e = A_0.e * num3;
				A_1.f = A_0.f * num3;
				A_1.g = A_0.g * num3;
			}
			else
			{
				A_1 = A_0;
			}
		}
		else
		{
			A_1 = A_0;
		}
		A_1.h = 0f;
	}

	public static v c(v A_0)
	{
		b(ref A_0, out var A_1);
		return A_1;
	}

	public static void a(ref v A_0, out v A_1)
	{
		v v2 = A_0;
		A_1 = v2;
		A_1.e();
	}

	public static v b(v A_0)
	{
		A_0.e();
		return A_0;
	}

	public static void a(ref a A_0, float A_1, out v A_2)
	{
		SharpDX.a.a(ref A_0, out var A_3);
		float num = A_1 * 0.5f;
		float num2 = (float)Math.Sin(num);
		float num3 = (float)Math.Cos(num);
		A_2.e = A_3.g * num2;
		A_2.f = A_3.h * num2;
		A_2.g = A_3.i * num2;
		A_2.h = num3;
	}

	public static v a(a A_0, float A_1)
	{
		a(ref A_0, A_1, out var A_2);
		return A_2;
	}

	public static void a(ref q A_0, out v A_1)
	{
		float num = A_0.d + A_0.i + A_0.n;
		if (num > 0f)
		{
			float num2 = (float)Math.Sqrt(num + 1f);
			A_1.h = num2 * 0.5f;
			num2 = 0.5f / num2;
			A_1.e = (A_0.j - A_0.m) * num2;
			A_1.f = (A_0.l - A_0.f) * num2;
			A_1.g = (A_0.e - A_0.h) * num2;
		}
		else if (A_0.d >= A_0.i && A_0.d >= A_0.n)
		{
			float num2 = (float)Math.Sqrt(1f + A_0.d - A_0.i - A_0.n);
			float num3 = 0.5f / num2;
			A_1.e = 0.5f * num2;
			A_1.f = (A_0.e + A_0.h) * num3;
			A_1.g = (A_0.f + A_0.l) * num3;
			A_1.h = (A_0.j - A_0.m) * num3;
		}
		else if (A_0.i > A_0.n)
		{
			float num2 = (float)Math.Sqrt(1f + A_0.i - A_0.d - A_0.n);
			float num3 = 0.5f / num2;
			A_1.e = (A_0.h + A_0.e) * num3;
			A_1.f = 0.5f * num2;
			A_1.g = (A_0.m + A_0.j) * num3;
			A_1.h = (A_0.l - A_0.f) * num3;
		}
		else
		{
			float num2 = (float)Math.Sqrt(1f + A_0.n - A_0.d - A_0.i);
			float num3 = 0.5f / num2;
			A_1.e = (A_0.l + A_0.f) * num3;
			A_1.f = (A_0.m + A_0.j) * num3;
			A_1.g = 0.5f * num2;
			A_1.h = (A_0.e - A_0.h) * num3;
		}
	}

	public static v a(q A_0)
	{
		a(ref A_0, out var A_1);
		return A_1;
	}

	public static void a(float A_0, float A_1, float A_2, out v A_3)
	{
		float num = A_2 * 0.5f;
		float num2 = A_1 * 0.5f;
		float num3 = A_0 * 0.5f;
		float num4 = (float)Math.Sin(num);
		float num5 = (float)Math.Cos(num);
		float num6 = (float)Math.Sin(num2);
		float num7 = (float)Math.Cos(num2);
		float num8 = (float)Math.Sin(num3);
		float num9 = (float)Math.Cos(num3);
		A_3.e = num9 * num6 * num5 + num8 * num7 * num4;
		A_3.f = num8 * num7 * num5 - num9 * num6 * num4;
		A_3.g = num9 * num7 * num4 - num8 * num6 * num5;
		A_3.h = num9 * num7 * num5 + num8 * num6 * num4;
	}

	public static v a(float A_0, float A_1, float A_2)
	{
		a(A_0, A_1, A_2, out var A_3);
		return A_3;
	}

	public static void a(ref v A_0, ref v A_1, float A_2, out v A_3)
	{
		float value = f(A_0, A_1);
		float num;
		float num2;
		if (Math.Abs(value) > 0.999999f)
		{
			num = 1f - A_2;
			num2 = A_2 * (float)Math.Sign(value);
		}
		else
		{
			float num3 = (float)Math.Acos(Math.Abs(value));
			float num4 = (float)(1.0 / Math.Sin(num3));
			num = (float)Math.Sin((1f - A_2) * num3) * num4;
			num2 = (float)Math.Sin(A_2 * num3) * num4 * (float)Math.Sign(value);
		}
		A_3.e = num * A_0.e + num2 * A_1.e;
		A_3.f = num * A_0.f + num2 * A_1.f;
		A_3.g = num * A_0.g + num2 * A_1.g;
		A_3.h = num * A_0.h + num2 * A_1.h;
	}

	public static v a(v A_0, v A_1, float A_2)
	{
		a(ref A_0, ref A_1, A_2, out var A_3);
		return A_3;
	}

	public static void a(ref v A_0, ref v A_1, ref v A_2, ref v A_3, float A_4, out v A_5)
	{
		a(ref A_0, ref A_3, A_4, out var A_6);
		a(ref A_1, ref A_2, A_4, out var A_7);
		a(ref A_6, ref A_7, 2f * A_4 * (1f - A_4), out A_5);
	}

	public static v a(v A_0, v A_1, v A_2, v A_3, float A_4)
	{
		a(ref A_0, ref A_1, ref A_2, ref A_3, A_4, out var A_5);
		return A_5;
	}

	public static v[] a(v A_0, v A_1, v A_2, v A_3)
	{
		v a_ = ((e(A_0, A_1).c() < d(A_0, A_1).c()) ? a(A_0) : A_0);
		v A_4 = ((e(A_1, A_2).c() < d(A_1, A_2).c()) ? a(A_2) : A_2);
		v a_2 = ((e(A_2, A_3).c() < d(A_2, A_3).c()) ? a(A_3) : A_3);
		v A_5 = A_1;
		d(ref A_5, out var A_6);
		d(ref A_4, out var A_7);
		return new v[3]
		{
			c(A_5, e(a(-0.25f, e(c(c(A_6, A_4)), c(c(A_6, a_)))))),
			c(A_4, e(a(-0.25f, e(c(c(A_7, a_2)), c(c(A_7, A_5)))))),
			A_4
		};
	}

	[SpecialName]
	public static v e(v A_0, v A_1)
	{
		c(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static v d(v A_0, v A_1)
	{
		b(ref A_0, ref A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static v a(v A_0)
	{
		f(ref A_0, out var A_1);
		return A_1;
	}

	[SpecialName]
	public static v a(float A_0, v A_1)
	{
		a(ref A_1, A_0, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static v a(v A_0, float A_1)
	{
		a(ref A_0, A_1, out var A_2);
		return A_2;
	}

	[SpecialName]
	public static v c(v A_0, v A_1)
	{
		a(ref A_0, ref A_1, out v A_2);
		return A_2;
	}

	[SpecialName]
	public static bool b(v A_0, v A_1)
	{
		return A_0.h(A_1);
	}

	[SpecialName]
	public static bool a(v A_0, v A_1)
	{
		return !A_0.h(A_1);
	}

	public string g()
	{
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1} Z:{2} W:{3}", this.e, this.f, this.g, this.h);
	}

	public string a(string A_0)
	{
		if (A_0 == null)
		{
			return ToString();
		}
		return string.Format(CultureInfo.CurrentCulture, "X:{0} Y:{1} Z:{2} W:{3}", this.e.ToString(A_0, CultureInfo.CurrentCulture), this.f.ToString(A_0, CultureInfo.CurrentCulture), this.g.ToString(A_0, CultureInfo.CurrentCulture), this.h.ToString(A_0, CultureInfo.CurrentCulture));
	}

	public string a(IFormatProvider A_0)
	{
		return string.Format(A_0, "X:{0} Y:{1} Z:{2} W:{3}", this.e, this.f, this.g, this.h);
	}

	public string a(string A_0, IFormatProvider A_1)
	{
		if (A_0 == null)
		{
			return a(A_1);
		}
		return string.Format(A_1, "X:{0} Y:{1} Z:{2} W:{3}", this.e.ToString(A_0, A_1), this.f.ToString(A_0, A_1), this.g.ToString(A_0, A_1), this.h.ToString(A_0, A_1));
	}

	string IFormattable.ToString(string A_0, IFormatProvider A_1)
	{
		//ILSpy generated this explicit interface implementation from .override directive in a
		return this.a(A_0, A_1);
	}

	public int f()
	{
		return this.e.GetHashCode() + this.f.GetHashCode() + this.g.GetHashCode() + this.h.GetHashCode();
	}

	public bool h(v A_0)
	{
		if (Math.Abs(A_0.e - this.e) < 1E-06f && Math.Abs(A_0.f - this.f) < 1E-06f && Math.Abs(A_0.g - this.g) < 1E-06f)
		{
			return Math.Abs(A_0.h - this.h) < 1E-06f;
		}
		return false;
	}

	bool IEquatable<v>.Equals(v A_0)
	{
		//ILSpy generated this explicit interface implementation from .override directive in h
		return this.h(A_0);
	}

	public bool a(object A_0)
	{
		if (A_0 == null)
		{
			return false;
		}
		if ((object)A_0.GetType() != GetType())
		{
			return false;
		}
		return h((v)A_0);
	}
}
