using System;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;
using System.Runtime.InteropServices;
using log4net;

namespace Com.Raritan.Core.Impl;

internal class q
{
	private ILog m_a;

	public q(ILog A_0)
	{
		this.m_a = A_0;
	}

	private TcpClient a(string A_0, int A_1)
	{
		this.m_a.DebugFormat("Using direct connection to '{0}' on port {1}", A_0, A_1);
		return new TcpClient(A_0, A_1);
	}

	private TcpClient a(string A_0, int A_1, string A_2, int A_3, string A_4, string A_5)
	{
		this.m_a.DebugFormat("Using proxy connection to '{0}' on port {1}, proxy host: '{2}', proxy port: {3}, username: '{4}', password: '{5}'", A_0, A_1, A_2, A_3, string.IsNullOrEmpty(A_4) ? "<none>" : A_4, string.IsNullOrEmpty(A_5) ? "<none>" : "<not shown>");
		Com.Raritan.Core.k k2 = new Com.Raritan.Core.k(this.m_a);
		Com.Raritan.Core.n n2 = ((string.IsNullOrEmpty(A_4) || string.IsNullOrEmpty(A_5)) ? k2.a(ProxyType.Socks5, A_2, A_3) : k2.a(ProxyType.Socks5, A_2, A_3, A_4, A_5));
		return n2.i(A_0, A_1);
	}

	private IntPtr a(int A_0)
	{
		int A_1 = 0;
		if (Com.Raritan.Core.i.InternetQueryOption(IntPtr.Zero, A_0, IntPtr.Zero, ref A_1))
		{
			return IntPtr.Zero;
		}
		int lastWin32Error = Marshal.GetLastWin32Error();
		if (lastWin32Error != 122)
		{
			return IntPtr.Zero;
		}
		IntPtr intPtr = Marshal.AllocHGlobal(A_1);
		if (!Com.Raritan.Core.i.InternetQueryOption(IntPtr.Zero, 38, intPtr, ref A_1))
		{
			lastWin32Error = Marshal.GetLastWin32Error();
			Marshal.FreeHGlobal(intPtr);
			return IntPtr.Zero;
		}
		return intPtr;
	}

	private string b(int A_0)
	{
		IntPtr intPtr = a(A_0);
		if (intPtr == IntPtr.Zero)
		{
			return null;
		}
		string result = Marshal.PtrToStringAnsi(intPtr);
		Marshal.FreeHGlobal(intPtr);
		return result;
	}

	private string b()
	{
		return b(43);
	}

	private string a()
	{
		return b(44);
	}

	private bool a(out string A_0, out string A_1)
	{
		A_0 = (A_1 = null);
		IntPtr intPtr = a(38);
		if (intPtr == IntPtr.Zero)
		{
			return false;
		}
		Com.Raritan.Core.i.b b2 = (Com.Raritan.Core.i.b)Marshal.PtrToStructure(intPtr, typeof(Com.Raritan.Core.i.b));
		A_0 = Marshal.PtrToStringAnsi(b2.b);
		A_1 = Marshal.PtrToStringAnsi(b2.c);
		int num = b2.a;
		Marshal.FreeHGlobal(intPtr);
		this.m_a.DebugFormat("System Proxy Settings - proxy servers: '{0}', bypass list: '{1}', accessType: {2}", A_0, A_1, num switch
		{
			38 => "proxy", 
			0 => "preconfig", 
			1 => "direct", 
			_ => "unknown", 
		});
		if (num == 3)
		{
			return !string.IsNullOrEmpty(A_0);
		}
		return false;
	}

	private bool a(out string A_0, out int A_1, out List<string> A_2)
	{
		A_0 = null;
		A_1 = 0;
		A_2 = new List<string>();
		if (!a(out var A_3, out var A_4))
		{
			this.m_a.Debug("No proxy is used.");
			return false;
		}
		string[] array = A_3.Split(new char[1] { ' ' });
		if (array.Length == 0 || !array[0].Contains("="))
		{
			this.m_a.DebugFormat("Proxy list '{0}' does not contain SOCKS proxy.", A_3);
			return false;
		}
		string[] array2 = array;
		foreach (string text in array2)
		{
			string[] array3 = text.Split(new char[1] { '=' });
			if (array3.Length != 2 || array3[0].ToLower() != "socks")
			{
				continue;
			}
			string[] array4 = array3[1].Split(new char[1] { ':' });
			if (array4.Length == 2)
			{
				A_0 = array4[0];
				try
				{
					A_1 = int.Parse(array4[1]);
				}
				catch
				{
					A_1 = 1080;
				}
				break;
			}
		}
		if (A_0 == null)
		{
			this.m_a.DebugFormat("Proxy list '{0}' does not contain SOCKS proxy.", A_3);
			return false;
		}
		if (A_4 != null)
		{
			A_2.AddRange(A_4.Split(new char[1] { ' ' }));
		}
		this.m_a.DebugFormat("Found socks proxy settings - host: '{0}', port: {1}", A_0, A_1);
		return true;
	}

	private bool a(string A_0, List<string> A_1)
	{
		IPAddress[] hostAddresses = Dns.GetHostAddresses(A_0);
		if (hostAddresses == null || hostAddresses.Length == 0)
		{
			this.m_a.DebugFormat("Can't find host '{0}' address, so don't bypass", A_0);
			return false;
		}
		foreach (string item in A_1)
		{
			if ("<local>".Equals(item))
			{
				if (!A_0.Contains("."))
				{
					this.m_a.DebugFormat("Host '{0}' bypassed by '<local>' bypass rule", A_0);
					return true;
				}
				IPAddress[] array = hostAddresses;
				foreach (IPAddress address in array)
				{
					if (IPAddress.IsLoopback(address))
					{
						this.m_a.Debug("Local network bypassed by '<local>' bypass rule");
						return true;
					}
				}
			}
			else if (new Com.Raritan.Core.o(item).IsMatch(A_0))
			{
				this.m_a.DebugFormat("Host '{0}' bypassed by '{1}' bypass rule", A_0, item);
				return true;
			}
		}
		this.m_a.Debug("No proxy bypass rule applies");
		return false;
	}

	private bool a(string A_0, out string A_1, out int A_2)
	{
		if (!a(out A_1, out A_2, out var A_3))
		{
			return false;
		}
		return !a(A_0, A_3);
	}

	private bool a(string A_0, out string A_1, out int A_2, out string A_3, out string A_4)
	{
		A_3 = null;
		A_4 = null;
		if (!a(A_0, out A_1, out A_2))
		{
			return false;
		}
		A_3 = b();
		A_4 = a();
		return true;
	}

	public TcpClient b(string A_0, int A_1)
	{
		if (a(A_0, out var A_2, out var A_3, out var A_4, out var A_5))
		{
			return a(A_0, A_1, A_2, A_3, A_4, A_5);
		}
		return a(A_0, A_1);
	}
}
