using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.Runtime.CompilerServices;
using System.Threading;
using System.Xml;
using System.Xml.Serialization;
using System.Xml.XPath;
using Com.Raritan.KxGui.Preferences;
using log4net;

namespace Com.Raritan.KxGui.FavoriteDevices;

public class a
{
	[CompilerGenerated]
	private sealed class a
	{
		public AutoResetEvent a;

		public object b;

		public List<DevicePreferences> c;

		public void a(IAsyncResult A_0)
		{
			DevicePreferences devicePreferences = (DevicePreferences)A_0.AsyncState;
			string text = devicePreferences.IpAddress;
			try
			{
				IPHostEntry iPHostEntry = Dns.EndGetHostEntry(A_0);
				text = iPHostEntry.HostName;
			}
			catch (Exception ex)
			{
				Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("A error occurred while attempting to DNS GetHostEntry, ip=" + devicePreferences.IpAddress + ", dnsName=" + devicePreferences.DnsName + ", error=" + ex.Message);
			}
			if (devicePreferences.IpAddress.Equals(text))
			{
				text = Com.Raritan.KxGui.FavoriteDevices.c.k;
			}
			lock (b)
			{
				devicePreferences.DnsName = text;
				c.Remove(devicePreferences);
				if (c.Count == 0)
				{
					this.a.Set();
				}
			}
		}
	}

	private static readonly ILog m_a = LogManager.GetLogger(typeof(Com.Raritan.KxGui.FavoriteDevices.a));

	private static readonly string m_b = Path.Combine(Utils.HOME_DIR, "DeviceTree.xml");

	private readonly ApplicationPreferencesManager m_c;

	private Hashtable m_d;

	private Hashtable m_e;

	private Hashtable m_f;

	private Hashtable j;

	private Hashtable k;

	private int m_g;

	private static int m_h;

	private static readonly string[] m_i = new string[5] { "description", "ipAddress", "dnsName", "productType", "port" };

	public static ManualResetEvent l = new ManualResetEvent(initialState: false);

	internal a(ApplicationPreferencesManager A_0)
	{
		this.m_c = A_0;
	}

	public void f()
	{
		this.m_g = Com.Raritan.KxGui.FavoriteDevices.c.h;
		c();
		b();
		if (this.m_d != null)
		{
			a();
		}
	}

	private void c()
	{
		Com.Raritan.KxGui.FavoriteDevices.a.m_h = this.m_c.AppPreferences.BroadcastPort;
	}

	private void b()
	{
		//IL_0087: Unknown result type (might be due to invalid IL or missing references)
		//IL_008e: Expected O, but got Unknown
		this.m_d = new Hashtable();
		XmlDocument xmlDocument = Utils.GetXmlDocument(Com.Raritan.KxGui.FavoriteDevices.a.m_b);
		if (xmlDocument == null)
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Debug(Com.Raritan.KxGui.FavoriteDevices.a.m_b + " not found.");
			return;
		}
		XmlNodeList val = ((XmlNode)xmlDocument).SelectNodes("preferences/root[@type='user']/node[@name='RaritanDevices']/node");
		if (val == null)
		{
			return;
		}
		for (int i = 0; i < val.Count; i++)
		{
			XmlNode val2 = val[i];
			string value = ((XmlNode)val2.Attributes["name"]).Value;
			string transformedXml = Utils.GetTransformedXml("ToDevPreferences.xslt", val2.OuterXml);
			XmlSerializer val3 = new XmlSerializer(typeof(XmlDevicePreferences));
			try
			{
				XmlDevicePreferences xmlDevicePreferences = (XmlDevicePreferences)val3.Deserialize((TextReader)new StringReader(transformedXml));
				if (!this.m_d.ContainsKey(value) && !string.IsNullOrEmpty(xmlDevicePreferences.Description))
				{
					if (string.IsNullOrEmpty(xmlDevicePreferences.IpAddress) || xmlDevicePreferences.IpAddress.Equals("0.0.0.0") || xmlDevicePreferences.IpAddress.Equals("::0") || xmlDevicePreferences.IpAddress.Equals("0"))
					{
						xmlDevicePreferences.IpAddress = Com.Raritan.KxGui.FavoriteDevices.c.k;
					}
					if (string.IsNullOrEmpty(xmlDevicePreferences.DnsName))
					{
						xmlDevicePreferences.DnsName = Com.Raritan.KxGui.FavoriteDevices.c.k;
					}
					DevicePreferences value2 = new DevicePreferences(xmlDevicePreferences.ColorDepthAsEnum, xmlDevicePreferences.SmoothingAsEnum, xmlDevicePreferences.ConnectionSpeedAsEnum, xmlDevicePreferences.SmartCardReaderName, xmlDevicePreferences.IpAddress, xmlDevicePreferences.Description, xmlDevicePreferences.DnsName, xmlDevicePreferences.ProductType, xmlDevicePreferences.Port, xmlDevicePreferences.ConnectPlaybackDevice, xmlDevicePreferences.PlaybackDevice, xmlDevicePreferences.PlaybackFormat, xmlDevicePreferences.PlaybackBufferSize, xmlDevicePreferences.ConnectCaptureDevice, xmlDevicePreferences.CaptureDevice, xmlDevicePreferences.CaptureFormat, xmlDevicePreferences.CaptureBufferSize);
					this.m_d.Add(value, value2);
				}
			}
			catch
			{
			}
		}
	}

	private void a()
	{
		Thread thread = new Thread(i);
		thread.Name = "hostname look up";
		thread.Start();
	}

	private void i()
	{
		j = new Hashtable();
		k = new Hashtable();
		IDictionaryEnumerator enumerator = this.m_d.GetEnumerator();
		while (enumerator.MoveNext())
		{
			string dnsName = ((DevicePreferences)enumerator.Value).DnsName;
			string ipAddress = ((DevicePreferences)enumerator.Value).IpAddress;
			if ((!ipAddress.Equals(Com.Raritan.KxGui.FavoriteDevices.c.k) && dnsName.Equals(Com.Raritan.KxGui.FavoriteDevices.c.k)) || (ipAddress.Equals(Com.Raritan.KxGui.FavoriteDevices.c.k) && !dnsName.Equals(Com.Raritan.KxGui.FavoriteDevices.c.k)))
			{
				k.Add(enumerator.Key, enumerator.Value);
			}
		}
		if (k.Count <= 0)
		{
			return;
		}
		Thread thread = new Thread(h);
		thread.Start();
		if (!thread.Join(120000))
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Debug("Timeout, kill thread DnsLookupStart");
			thread.Abort();
		}
		Hashtable hashtable = new Hashtable();
		IDictionaryEnumerator enumerator2 = j.GetEnumerator();
		while (enumerator2.MoveNext())
		{
			string text = (string)enumerator2.Key;
			string text2 = (string)enumerator2.Value;
			IDictionaryEnumerator enumerator3 = k.GetEnumerator();
			while (enumerator3.MoveNext())
			{
				DevicePreferences devicePreferences = (DevicePreferences)enumerator3.Value;
				if (text.Equals(devicePreferences.IpAddress) || text2.Equals(devicePreferences.DnsName))
				{
					DevicePreferences value = new DevicePreferences(devicePreferences.ColorDepth, devicePreferences.Smoothing, devicePreferences.ConnectionSpeed, devicePreferences.SmartCardReaderName, text, devicePreferences.Description, text2, devicePreferences.ProductType, devicePreferences.Port, devicePreferences.ConnectPlaybackDevice, devicePreferences.PlaybackDevice, devicePreferences.PlaybackFormat, devicePreferences.PlaybackBufferSize, devicePreferences.ConnectCaptureDevice, devicePreferences.CaptureDevice, devicePreferences.CaptureFormat, devicePreferences.CaptureBufferSize);
					hashtable.Add(enumerator3.Key, value);
					break;
				}
			}
		}
		if (hashtable.Count > 0 && a(hashtable))
		{
			b();
		}
	}

	private void h()
	{
		IDictionaryEnumerator enumerator = k.GetEnumerator();
		int num = 0;
		try
		{
			l.Reset();
			while (enumerator.MoveNext())
			{
				string text = ((DevicePreferences)enumerator.Value).IpAddress;
				if (text.Equals(Com.Raritan.KxGui.FavoriteDevices.c.k))
				{
					text = ((DevicePreferences)enumerator.Value).DnsName;
				}
				if (!text.Equals("0"))
				{
					try
					{
						Dns.BeginGetHostEntry(text, a, null);
						num++;
					}
					catch (Exception ex)
					{
						Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("A error occurred while attempting to DNS BeginGetHostEntry: " + ex.Message);
					}
				}
			}
			for (int i = 0; i < num; i++)
			{
				l.WaitOne();
				l.Reset();
			}
		}
		catch (Exception ex2)
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("Exception in DnsLookupStart: " + ex2.Message);
		}
	}

	private void a(IAsyncResult A_0)
	{
		try
		{
			IPHostEntry iPHostEntry = Dns.EndGetHostEntry(A_0);
			string hostName = iPHostEntry.HostName;
			string text = iPHostEntry.AddressList[0].ToString();
			if (string.IsNullOrEmpty(text))
			{
				text = Com.Raritan.KxGui.FavoriteDevices.c.k;
			}
			if (string.IsNullOrEmpty(hostName) || (!string.IsNullOrEmpty(text) && text.Equals(hostName)))
			{
				hostName = Com.Raritan.KxGui.FavoriteDevices.c.k;
			}
			if (!text.Equals(Com.Raritan.KxGui.FavoriteDevices.c.k) && !hostName.Equals(Com.Raritan.KxGui.FavoriteDevices.c.k))
			{
				j.Add(text, hostName);
			}
		}
		catch (Exception ex)
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("Cannot find host info: " + ex.Message);
		}
		l.Set();
	}

	public string a(string A_0, int A_1)
	{
		try
		{
			if (A_0 != null)
			{
				return b(A_0, A_1);
			}
			return a(A_1);
		}
		catch (Exception ex)
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("DiscoverDevices Exception: " + ex.Message);
		}
		return "";
	}

	public string e()
	{
		return Com.Raritan.KxGui.FavoriteDevices.c.b(this.m_d, this.m_g);
	}

	public void c(int A_0)
	{
		this.m_g = A_0;
	}

	public string d()
	{
		return Com.Raritan.KxGui.FavoriteDevices.c.a(Com.Raritan.KxGui.FavoriteDevices.a.m_i, Com.Raritan.KxGui.FavoriteDevices.c.f);
	}

	public string d(string A_0)
	{
		if (A_0 != null && this.m_d.ContainsKey(A_0))
		{
			DevicePreferences devicePreferences = (DevicePreferences)this.m_d[A_0];
			string[] a_ = new string[5] { devicePreferences.Description, devicePreferences.IpAddress, devicePreferences.DnsName, devicePreferences.ProductType, devicePreferences.Port };
			return Com.Raritan.KxGui.FavoriteDevices.c.a(a_, Com.Raritan.KxGui.FavoriteDevices.c.f);
		}
		Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("cannot find the node with name:" + A_0);
		return null;
	}

	public bool f(string A_0)
	{
		if (A_0 != null)
		{
			return this.m_d.ContainsKey(A_0);
		}
		return false;
	}

	public bool a(string A_0, string A_1)
	{
		if (A_0 != null && this.m_d.ContainsKey(A_0) && !string.IsNullOrEmpty(A_1))
		{
			string description = ((DevicePreferences)this.m_d[A_0]).Description;
			return description.Equals(A_1);
		}
		return false;
	}

	public void a(string A_0, string A_1, string A_2, string A_3)
	{
		try
		{
			string hostName = Com.Raritan.KxGui.FavoriteDevices.c.k;
			IPAddress iPAddress;
			try
			{
				IPHostEntry hostEntry = Dns.GetHostEntry(A_0);
				iPAddress = hostEntry.AddressList[0];
				hostName = hostEntry.HostName;
			}
			catch (Exception)
			{
				iPAddress = Dns.GetHostAddresses(A_0)[0];
			}
			string text = iPAddress.ToString();
			if (text.Equals(hostName))
			{
				hostName = Com.Raritan.KxGui.FavoriteDevices.c.k;
			}
			Hashtable hashtable = new Hashtable();
			hashtable.Add(A_0, new DevicePreferences(null, null, null, null, text, A_1, hostName, A_3, A_2, connectPlaybackDevice: true, null, null, 120, connectCaptureDevice: false, null, null, 120));
			if (a(hashtable))
			{
				b();
			}
		}
		catch (Exception ex2)
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("Failed to resolve the hostname " + A_0 + ", Exception: " + ex2);
		}
	}

	public void a(string A_0, string A_1, string A_2, string A_3, string A_4)
	{
		if (string.IsNullOrEmpty(A_0) || string.IsNullOrEmpty(A_1))
		{
			return;
		}
		DevicePreferences devicePreferences = (DevicePreferences)this.m_d[A_1];
		string text = devicePreferences.IpAddress;
		string text2 = devicePreferences.DnsName;
		if (!A_0.Equals(A_1))
		{
			try
			{
				text2 = Com.Raritan.KxGui.FavoriteDevices.c.k;
				try
				{
					IPHostEntry hostEntry = Dns.GetHostEntry(A_0);
					text = hostEntry.AddressList[0].ToString();
					text2 = hostEntry.HostName;
				}
				catch (Exception)
				{
					text = Dns.GetHostAddresses(A_0)[0].ToString();
				}
				if (text.Equals(text2))
				{
					text2 = Com.Raritan.KxGui.FavoriteDevices.c.k;
				}
				a(A_1);
			}
			catch (Exception ex2)
			{
				Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("Failed to resolve the hostname " + A_0 + ", Exception: " + ex2);
			}
		}
		Hashtable hashtable = new Hashtable();
		hashtable.Add(A_0, new DevicePreferences(devicePreferences.ColorDepth, devicePreferences.Smoothing, devicePreferences.ConnectionSpeed, devicePreferences.SmartCardReaderName, text, A_2, text2, A_4, A_3, devicePreferences.ConnectPlaybackDevice, devicePreferences.PlaybackDevice, devicePreferences.PlaybackFormat, devicePreferences.PlaybackBufferSize, devicePreferences.ConnectCaptureDevice, devicePreferences.CaptureDevice, devicePreferences.CaptureFormat, devicePreferences.CaptureBufferSize));
		if (a(hashtable))
		{
			b();
		}
	}

	public void e(string A_0)
	{
		if (!string.IsNullOrEmpty(A_0) && a(A_0))
		{
			b();
		}
	}

	public string a(string A_0, bool A_1)
	{
		if (string.IsNullOrEmpty(A_0))
		{
			return "";
		}
		Hashtable hashtable = (A_1 ? this.m_f : this.m_e);
		Hashtable hashtable2 = new Hashtable();
		string[] array = A_0.Split(new char[1] { '\u001e' });
		for (int i = 0; i < array.Length; i++)
		{
			hashtable2.Add(array[i], hashtable[array[i]]);
		}
		if (a(hashtable2))
		{
			for (int j = 0; j < array.Length; j++)
			{
				if (hashtable.ContainsKey(array[j]))
				{
					hashtable.Remove(array[j]);
				}
			}
			b();
		}
		return e();
	}

	private string b(string A_0, int A_1)
	{
		string text = Com.Raritan.KxGui.FavoriteDevices.b.a(A_0, A_1);
		if (string.IsNullOrEmpty(text))
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Info("KX discovery responses are empty.");
			return "";
		}
		this.m_f = new Hashtable();
		Hashtable hashtable = new Hashtable();
		Hashtable hashtable2 = new Hashtable();
		StringReader stringReader = new StringReader(text);
		string text2 = stringReader.ReadLine();
		List<DevicePreferences> list = new List<DevicePreferences>();
		bool flag = Com.Raritan.KxGui.FavoriteDevices.c.a();
		while (!string.IsNullOrEmpty(text2))
		{
			int num = text2.IndexOf("<");
			if (num <= 0)
			{
				Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("Failed to parse discovery data provided by KX: " + text2);
			}
			else
			{
				string text3 = text2.Substring(0, num - 1).Trim();
				IPAddress iPAddress = IPAddress.Parse(text3);
				Dictionary<string, string> dictionary = Com.Raritan.KxGui.FavoriteDevices.c.a(text2.Substring(num - 1));
				string text4 = null;
				if (dictionary != null)
				{
					if (iPAddress != null && iPAddress.IsIPv6LinkLocal && dictionary.ContainsKey("Device.IPAddress_v6"))
					{
						text3 = dictionary["Device.IPAddress_v6"];
					}
					if (dictionary.ContainsKey("Device.id"))
					{
						text4 = dictionary["Device.id"];
					}
					if (string.IsNullOrEmpty(text3) || !c(text3) || this.m_d.ContainsKey(text3))
					{
						hashtable2.Add(text4, text3);
						text2 = stringReader.ReadLine();
						continue;
					}
					if (iPAddress != null && iPAddress.IsIPv6LinkLocal && !flag)
					{
						text2 = stringReader.ReadLine();
						continue;
					}
					DevicePreferences devicePreferences = Com.Raritan.KxGui.FavoriteDevices.c.a(text3, dictionary, list);
					if (devicePreferences != null)
					{
						if (text4 != null)
						{
							if (hashtable.ContainsKey(text4))
							{
								if (iPAddress != null && iPAddress.IsIPv6LinkLocal)
								{
									DevicePreferences devicePreferences2 = (DevicePreferences)hashtable[text4];
									if (devicePreferences2 != null && devicePreferences2.IpAddress != null)
									{
										this.m_f.Remove(devicePreferences2.IpAddress);
										this.m_f.Add(text3, devicePreferences);
										hashtable.Remove(text4);
										hashtable.Add(text4, devicePreferences);
									}
								}
							}
							else if (!hashtable2.ContainsKey(text4))
							{
								this.m_f.Add(text3, devicePreferences);
								hashtable.Add(text4, devicePreferences);
							}
						}
					}
					else
					{
						Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error($"Failed to get device preferences by (key, info): ({text3}, {dictionary})");
					}
				}
				else
				{
					Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("Invalided ipAddress provided by KX: " + text3);
				}
			}
			text2 = stringReader.ReadLine();
		}
		a(list);
		foreach (string key in hashtable.Keys)
		{
			if (hashtable2.ContainsKey(key))
			{
				DevicePreferences devicePreferences3 = (DevicePreferences)hashtable[key];
				if (devicePreferences3 != null && devicePreferences3.IpAddress != null)
				{
					this.m_f.Remove(devicePreferences3.IpAddress);
				}
			}
		}
		int a_ = ((this.m_g == Com.Raritan.KxGui.FavoriteDevices.c.j) ? Com.Raritan.KxGui.FavoriteDevices.c.i : this.m_g);
		return Com.Raritan.KxGui.FavoriteDevices.c.b(this.m_f, a_);
	}

	private string a(int A_0)
	{
		int a_ = ((A_0 == -1) ? Com.Raritan.KxGui.FavoriteDevices.a.m_h : A_0);
		Dictionary<string, Dictionary<string, string>> dictionary = Com.Raritan.KxGui.FavoriteDevices.b.c(a_);
		if (dictionary == null)
		{
			return "";
		}
		this.m_e = new Hashtable();
		Dictionary<string, Dictionary<string, string>>.Enumerator enumerator = dictionary.GetEnumerator();
		List<DevicePreferences> list = new List<DevicePreferences>();
		while (enumerator.MoveNext())
		{
			string key = enumerator.Current.Key;
			Dictionary<string, string> value = enumerator.Current.Value;
			if (!string.IsNullOrEmpty(key) && value != null && !this.m_d.ContainsKey(key))
			{
				DevicePreferences devicePreferences = Com.Raritan.KxGui.FavoriteDevices.c.a(key, value, list);
				if (devicePreferences != null)
				{
					this.m_e.Add(key, devicePreferences);
				}
			}
			else
			{
				Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("Failed to parse client discovery data");
			}
		}
		a(list);
		int a_2 = ((this.m_g == Com.Raritan.KxGui.FavoriteDevices.c.j) ? Com.Raritan.KxGui.FavoriteDevices.c.i : this.m_g);
		return Com.Raritan.KxGui.FavoriteDevices.c.b(this.m_e, a_2);
	}

	private bool a(string A_0)
	{
		if (string.IsNullOrEmpty(A_0))
		{
			return false;
		}
		XmlDocument xmlDocument = Utils.GetXmlDocument(Com.Raritan.KxGui.FavoriteDevices.a.m_b);
		if (xmlDocument == null)
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("cannot open file");
			return false;
		}
		XPathNavigator val = ((XmlNode)xmlDocument).CreateNavigator();
		string[] array = A_0.Split(new char[1] { '\u001e' });
		for (int i = 0; i < array.Length; i++)
		{
			string text = "preferences/root[@type='user']/node[@name='RaritanDevices']/node[@name='" + array[i] + "']";
			XPathNavigator val2 = val.SelectSingleNode(text);
			if (val2 != null)
			{
				val2.DeleteSelf();
			}
		}
		try
		{
			xmlDocument.Save(Com.Raritan.KxGui.FavoriteDevices.a.m_b);
		}
		catch (Exception exception)
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("Falied to delete node from " + Com.Raritan.KxGui.FavoriteDevices.a.m_b, exception);
			return false;
		}
		return true;
	}

	private bool a(Hashtable A_0)
	{
		XmlDocument val = Utils.GetXmlDocument(Com.Raritan.KxGui.FavoriteDevices.a.m_b);
		if (val == null)
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Info("cannot open file:" + Com.Raritan.KxGui.FavoriteDevices.a.m_b);
			val = Utils.GetPrefernecesTemplate("DevPreferencesTemplate.xml");
		}
		XPathNavigator val2 = ((XmlNode)val).CreateNavigator();
		IDictionaryEnumerator enumerator = A_0.GetEnumerator();
		while (enumerator.MoveNext())
		{
			string data = Utils.Serialize(new XmlDevicePreferences((DevicePreferences)enumerator.Value, (string)enumerator.Key));
			string text = string.Concat("preferences/root[@type='user']/node[@name='RaritanDevices']/node[@name='", enumerator.Key, "']");
			XPathNavigator val3 = val2.SelectSingleNode(text);
			if (val3 == null)
			{
				val3 = val2.SelectSingleNode("preferences/root[@type='user']/node[@name='RaritanDevices']");
				val3.AppendChild(Utils.GetTransformedXml("FromDevPreferences.xslt", data));
				continue;
			}
			XPathNavigator val4 = val2.SelectSingleNode(text + "/map/entry[@key='g2ConnectionSpeed']");
			if (val4 != null)
			{
				val4.DeleteSelf();
			}
			val4 = val2.SelectSingleNode(text + "/map/entry[@key='g2Smoothing']");
			if (val4 != null)
			{
				val4.DeleteSelf();
			}
			val4 = val2.SelectSingleNode(text + "/map/entry[@key='g2ColorDepth']");
			if (val4 != null)
			{
				val4.DeleteSelf();
			}
			val4 = val2.SelectSingleNode(text + "/map/entry[@key='autoMountSmartCardReaderName']");
			if (val4 != null)
			{
				val4.DeleteSelf();
			}
			val4 = val2.SelectSingleNode(text + "/map/entry[@key='ipAddress']");
			if (val4 != null)
			{
				val4.DeleteSelf();
			}
			val4 = val2.SelectSingleNode(text + "/map/entry[@key='dnsName']");
			if (val4 != null)
			{
				val4.DeleteSelf();
			}
			val4 = val2.SelectSingleNode(text + "/map/entry[@key='description']");
			if (val4 != null)
			{
				val4.DeleteSelf();
			}
			val4 = val2.SelectSingleNode(text + "/map/entry[@key='port']");
			if (val4 != null)
			{
				val4.DeleteSelf();
			}
			val4 = val2.SelectSingleNode(text + "/map/entry[@key='productType']");
			if (val4 != null)
			{
				val4.DeleteSelf();
			}
			val3 = val2.SelectSingleNode(text + "/map");
			val3.AppendChild(Utils.GetTransformedXml("FromDevPrefEntries.xslt", data));
		}
		try
		{
			val.Save(Com.Raritan.KxGui.FavoriteDevices.a.m_b);
		}
		catch (Exception exception)
		{
			Com.Raritan.KxGui.FavoriteDevices.a.m_a.Warn("Falied to add/modify " + Com.Raritan.KxGui.FavoriteDevices.a.m_b, exception);
			return false;
		}
		return true;
	}

	public void b(int A_0)
	{
		//IL_007a: Unknown result type (might be due to invalid IL or missing references)
		if (Com.Raritan.KxGui.FavoriteDevices.a.m_h != A_0 && A_0 <= 65535 && A_0 >= 0)
		{
			ApplicationPreferencesManager applicationPreferencesManager = new ApplicationPreferencesManager();
			ApplicationPreferences appPreferences = applicationPreferencesManager.AppPreferences;
			ApplicationPreferences pref = new ApplicationPreferences(appPreferences.LogEnabled, appPreferences.EnableLaunchInFS, appPreferences.KeyboardType, appPreferences.SingleMouseExitHotKey, appPreferences.KeyboardMenuHotKey, appPreferences.ConnectionExitHotKey, A_0, appPreferences.Screen, appPreferences.EnableLaunchWithSMM, appPreferences.EnableLaunchWithScaling, appPreferences.PinMenuToolbar, appPreferences.ScanDisplayInterval, appPreferences.PortScanInterval, appPreferences.ScanThumbnailSize, appPreferences.ScanOrientation);
			try
			{
				applicationPreferencesManager.PersistAppPreferences(pref);
			}
			catch (Exception exception)
			{
				Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("Exception on saving Application preferences", exception);
			}
			Com.Raritan.KxGui.FavoriteDevices.a.m_h = A_0;
		}
	}

	public int g()
	{
		return Com.Raritan.KxGui.FavoriteDevices.a.m_h;
	}

	public bool c(string A_0)
	{
		bool result = false;
		if (!string.IsNullOrEmpty(A_0))
		{
			try
			{
				Dns.GetHostAddresses(A_0);
				result = true;
			}
			catch (Exception exception)
			{
				string message = "Failed to resolve the hostname " + A_0;
				Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error(message, exception);
			}
		}
		return result;
	}

	private void a(List<DevicePreferences> A_0)
	{
		if (A_0 == null || A_0.Count == 0)
		{
			return;
		}
		AutoResetEvent a2 = new AutoResetEvent(initialState: false);
		object b2 = new object();
		AsyncCallback requestCallback = delegate(IAsyncResult A_0)
		{
			DevicePreferences devicePreferences = (DevicePreferences)A_0.AsyncState;
			string text = devicePreferences.IpAddress;
			try
			{
				IPHostEntry iPHostEntry = Dns.EndGetHostEntry(A_0);
				text = iPHostEntry.HostName;
			}
			catch (Exception ex)
			{
				Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("A error occurred while attempting to DNS GetHostEntry, ip=" + devicePreferences.IpAddress + ", dnsName=" + devicePreferences.DnsName + ", error=" + ex.Message);
			}
			if (devicePreferences.IpAddress.Equals(text))
			{
				text = Com.Raritan.KxGui.FavoriteDevices.c.k;
			}
			lock (b2)
			{
				devicePreferences.DnsName = text;
				A_0.Remove(devicePreferences);
				if (A_0.Count == 0)
				{
					a2.Set();
				}
			}
		};
		lock (b2)
		{
			foreach (DevicePreferences item in A_0)
			{
				try
				{
					Dns.BeginGetHostEntry(item.IpAddress, requestCallback, item);
				}
				catch (Exception ex2)
				{
					Com.Raritan.KxGui.FavoriteDevices.a.m_a.Error("A error occurred while attempting to DNS GetHostEntry, ip=" + item.IpAddress + ", dnsName=" + item.DnsName + ", error=" + ex2.Message);
				}
			}
		}
		a2.WaitOne();
		a2.Close();
	}
}
